#!/bin/sh
# This file executes on combined deltas.
#
# find what machine we are running on and copy the correct files
# to current directory.

if /bin/i386
then
	MACH=i386
fi
if /bin/ns32000
then
	MACH=ns32000
fi
VERSION=`/etc/version | awk '{ print $2 }'`
VERSION=`expr $VERSION : '\([^.]*.[^.*]\).*'`

echo "Combined delta distribution of:"
echo
for dir in i386_* ns32000_*
do
	if [ -d $dir ]
	then
		echo "	$dir"
	fi
done
echo

echo "Currently running $VERSION for $MACH"
echo
DIR=`echo ${MACH}_${VERSION}*`
if [ -d "${DIR}" ]
then
	echo "Using ${DIR} "
	echo
	for file in  ${DIR}/* 
	do
		ln $file .
	done
else
	echo "Unable to determine which delta tools to use"
fi
