.\"$Copyright:	$
."Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
."Sequent Computer Systems, Inc.   All rights reserved.
." 
."This software is furnished under a license and may be used
."only in accordance with the terms of that license and with the
."inclusion of the above copyright notice.   This software may not
."be provided or otherwise made available to, or used by, any
."other person.  No title to or ownership of the software is
."hereby transferred.
.\"
...
.V= $Header: quotausr.t 1.1 90/01/03 $
.Mt "1003-47671-00"
.Ct "" "" "Disk Quota Operations for Users"
.Rh A
.FS
DYNIX is a registered trademark of Sequent Computer Systems, Inc.
.br
Sun and NFS are trademarks of Sun Microsystems, Inc.
.FE
This information is for users.  It explains how to perform disk quota
operations.
.Ah "Usage Limits"
The system administrator can set quotas to limit the
number of 1K blocks and the
number of inodes (files) that you can have on a specified
filesystem at one time.  The limits may be different on different
filesystems.
There are two limits, a hard limit and a soft limit.
.Pa
A hard limit is a final limit.  When you reach it, you
get an error message and cannot have any more of the resource.
When the condition first occurs, a message is
written to your terminal.  The message is not repeated.
You must reduce the number of blocks or files you hold.
For example, if you reach the file (inode) limit,
an error message appears and the file is not created.  You
can still add blocks to existing files if the number of blocks 
used hasn't reached the limit.
.Pa
A soft limit is a warning limit.  If this is lower than the hard
limit (the useful case), you get a warning when the limit is
reached and a timer is set.  You have the specified amount of
time to bring disk use back under the soft limit. 
If you do not reduce usage within the time allowed,
the soft limit is treated as a hard limit.  It continues to
be treated as a hard limit
until usage falls below the soft limit.
.Ah "Checking Limits and Usage"
You may check your own limits and usage by invoking
the \f3quota\fP(1) command.
You cannot check anyone else's limits.
.Ah "Responding After Reaching a Quota Limit"
In most cases, to recover from reaching your hard quota limit you must
abort the process or processes in progress on the filesystem where
you
reached the limit, remove enough files to bring the limit back below
quota, and retry the failed program.
.Pa
The case is different when you are in the editor and a write fails
because it exceeds your quota.  Most likely, the write attempt that
generated the \*Qquota exceeded\*U
message also truncated the file in the
editor.  If you abort the editor in these circumstances, you will not
only lose recent changes, but probably some, or all, of the file proper
as well. 
You may exit from this situation safely in any of the following
ways:
.Ls B
.Li
You may use
the editor shell escape command
(normally \f(LB!\fP) 
to check your file space and remove surplus files. 
For example, type \f(LB!\fP while in the
editor and execute a command to the shell prompt.
.Li
If you use \f3csh\fP, you may suspend the editing
session while you remove some files.
(This method is probably
quicker). 
For example, while in the editor
enter
\*<CTRL-Z\*>
(press the CTRL key and the Z key simultaneously) and you
will be returned to the C shell.  You may use as many
commands as you need to
remove files and get below your quota limit.  When you are ready to
continue the editing session, type \f3fg\fP (for foreground) to
the shell prompt, and the suspended editor will restart. 
.Li
You may write the file to some other filesystem (perhaps to a
file on \f2/tmp\fP) where your quota has not been exceeded.  After
rectifying the quota problem, you can move the file back to the
filesystem where it belongs.
.Bh "Quotas and the NFS"
Quotas on remotely mounted filesystems work much the same as quotas on
locally mounted filesystems.  The important difference is that no
warnings are printed when you reach the soft limit. 
The operating system does not give an error message if you reach
the hard limit, and the program you are running may or may not
give a message.  This means that you cannot rely on error
messages to remain within your limits, and you need to
use \f3quota\fP(1) to check your quotas.
.Pa
The noquota option may be set for a remotely mounted filesystem.
If this is the case, your quotas are not checked automatically.
However, you may check
the filesystems 
by invoking
\f3quota \-v\fP.
