/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

/* $Header: conf_sd.c 2.4 89/09/05 $ */

#include <sys/param.h>
#include <sys/inode.h>
#include <sys/fs.h>
#include "saio.h"
#include "scsi.h"
#include "ccs.h"
#include "sdreg.h"

#define	A_PART	15884
#define	B_PART	33440
#define	D_PART	15884
#define	F_PART	300575

/* tables for partition mapping */
static	daddr_t sd5_25[8] = { 
/*	offset 	*/
	0, 			/* 0 - partition 'a' */
	A_PART,			/* 1 - partition 'b' */
	0, 			/* 2 - partition 'c' */
	A_PART+B_PART, 		/* 3 - partition 'd' */
	A_PART+B_PART+D_PART,	/* 4 - partition 'e' */
	A_PART+B_PART, 		/* 3 - partition 'f' */
	A_PART+B_PART,		/* 3 - partition 'g' */
	A_PART+B_PART+F_PART,	/* 4 - partition 'h' */
};


/*
 * drive descriptions for supported SCSI disks.  All device types share the
 * same partition table.  Note: 8K bootstrap (BOOTXX) knows about only
 * one kind of SCSI disk.
 */

struct drive_type drive_table[] = {

	{ "fujitsu",
		"",
		"",
		/* last 3 cyls reserved: 2 for diags, 1 for bad blocks */
		{ 17, 11, 17*11, 751+3, sd5_25  },
		0,
	},

#ifndef BOOTXX
	{ "wren3",
		"CDC     ",
		"94161-9         ",
		{ 35, 9, 9*35, 965+2, sd5_25 },
		1, 4, SDF_FORMPG, SDM_ERROR, SDM_PF, SIZE_BDESC, SDE_PER
	},

	{ "wren4",
		"CDC     ",
		"94171-9         ",
		{ 54, 9, (9*54)-3, 1324+2, sd5_25 },
		1, 4, SDF_FORMPG, SDM_ERROR, SDM_PF, SIZE_BDESC, SDE_PER
	},

	{ "microp1375",
		"MICROP  ",
		"1375            ",
		{ 35, 8, 8*35, 1016+2, sd5_25 },
		1, 4, SDF_FORMPG, SDM_ERROR, SDM_PF, SIZE_BDESC, SDE_PER
	},

	{ "m2246s",
		"FUJITSU ",
		"M224XS          ",
		{ 33, 10, 33*10, 819+2, sd5_25 },
		1, 4, SDF_FORMPG, SDM_ERROR, SDM_PF, SIZE_BDESC, SDE_PER
	},

  	{ "m2249s",
  		"FUJITSU ",
  		"M2249SA         ",
  		{ 35, 15, 35*15, 1239+2, sd5_25 },
  		1, 4, SDF_FORMPG, SDM_ERROR, SDM_PF, SIZE_BDESC, SDE_PER
  	},
#endif BOOTXX
	{	(char*)0,		/* drive_table[] terminator */
	}
};

/*
 * the maximum number of badblocks handled at one time by sdformat.
 * This is not a limitation on the total number of bad blocks
 * that can be added to the disk, something defined by the disk
 * manufacturer.
 */

#define	MAXBADLIST	256

#ifdef STANDALONE
int	maxbadlist = MAXBADLIST;
int	list[MAXBADLIST];
#endif
