/* $Copyright:	$
 * Copyright (c) 1984, 1985 Sequent Computer Systems, Inc.
 * All rights reserved
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ifdef RCS
static char rcsid[] = "$Header: getchar.c 1.2 86/05/01 $";
#endif

/*
 * These control the getting and putting of chars
 */

#include <sys/types.h>
#include <machine/cfg.h>
#include <machine/hwparam.h>
#include <machine/slic.h>
#include <machine/mftpr.h>

#define RBUFSIZE	80
char _ring[RBUFSIZE];
char *_getp = _ring;
char *_putp = _ring;

getchar()
{

	return(_ci(1));
}

/* non blocking getchar */
igetchar()
{

	return(_ci(0));
}

/*
 * assume interrupts are turned off
 */
_ci(wait)
{
	register struct cpuslic *sl = (struct cpuslic *)LOAD_CPUSLICADDR;
	register int c;

	if (_putp != _getp) {
		c = *_getp++;
		if (_getp >= &_ring[RBUFSIZE])
			_getp -= RBUFSIZE;
		return ((unsigned char)c);
	}
	if (wait) 
		while ((sl->sl_ictl & SL_HARDINT) == 0)
			/* spin */;
	else 
		if ((sl->sl_ictl & SL_HARDINT) == 0)
			return(-1);
	c = sl->sl_binint; 
	sl->sl_binint = 0;
	return((unsigned char)c);
}

_put(c)
{
	if ((_putp == _getp - 1) || (_getp == _ring && _putp == &_ring[RBUFSIZE-1]))
		return;	/* discard */
	*_putp++ = (unsigned char) c;
	if (_putp >= &_ring[RBUFSIZE])
		_putp -= RBUFSIZE;
}
