
/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987 Sequent Computer Systems, Inc.
 * All rights reserved
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

/* $Header: sdformat.h 1.2 87/04/17 $ */


#define MANUALLY	0
#define FILE		1

/*
 * macros used in doing byte swapping.
 */

#define itob4(i, b) \
	b[3] = (u_char) i; \
	b[2] = (u_char) (i >> 8); \
	b[1] = (u_char) (i >> 16); \
	b[0] = (u_char) (i >> 24);

#define itob3(i, b) \
	b[2] = (u_char) i; \
	b[1] = (u_char) (i >> 8); \
	b[0] = (u_char) (i >> 16);

/*
 * format of a 6 byte command descriptor block (CDB)
 */

struct cmd6 {
	u_char cmd_opcode;
	u_char cmd_lun;
	u_char cmd_lba[2];
	u_char cmd_length;
	u_char cmd_cb;
};

/*
 * format of a 10 byte command descriptor block (CDB)
 */

struct cmd10 {
	u_char cmd_opcode;
	u_char cmd_lun;
	u_char cmd_lba[4];
	u_char cmd_pad;
	u_char cmd_length[2];
	u_char cmd_cb;
};

#define cmd_pgcode cmd_lba[0]		/* page code for MODE SENSE/SELECT */

/*
 * arguments to sdioctl().  This interface requires a packet which
 * contains the CDB in the first bytes and the data for the command
 * in the remaining bytes.
 */

struct modearg {		/* used for MODE SENSE/SELECT */
	struct cmd6 cmd;
	struct sd_modes mode;
};

struct inqarg {			/* used for INQUIRY */
	struct cmd6 cmd;
	struct sdinq inq;
};

struct formarg {		/* used for FORMAT UNIT */
	struct cmd6 cmd;
	u_char pad[4];
};

struct reassarg {		/* used for REASSIGN BLOCKS */
	struct cmd6 cmd;
	short  pad;
	u_char length[2];
	u_char defect[4];
};

struct readcarg {		/* used for READ CAPACITY */
	struct cmd10 cmd;
	u_char nblocks[4];		/* highest addressable block on disk */
	u_char bsize[4];		/* formatted size of disk blocks */
};

/*
 * tasks that can be done by the formatter
 */

struct task_type {
	int tt_cmd;
	char *tt_desc;
};

/*
 * tasks performable by the formatter
 */

#define EXIT	0
#define FORMAT	1
#define ADDBAD	2
#define DISPLAY	3

/*
 * Diagnostic Block Structure
 */
#define	CSD_DIAG_PAT_BYTES	(512 - sizeof(u_int))

struct csd_db {
	u_char	csd_db_pattern[CSD_DIAG_PAT_BYTES];	/* test pattern */
	u_int	csd_db_blkno;				/* block number */
};

/*
 * Worse case csd pattern: e739c
 */
#define	CSD_DIAG_PAT_0		0xe7	/* must be in byte 0 of the block */
#define	CSD_DIAG_PAT_1		0x39	/* must be in byte 1 of the block */
#define	CSD_DIAG_PAT_2		0xce	/* must be in byte 2 of the block */
#define	CSD_DIAG_PAT_3		0x73	/* must be in byte 3 of the block */
#define	CSD_DIAG_PAT_4		0x9c	/* must be in byte 4 of the block */
#define	CSD_DIAG_PAT_SIZE	5	/* repeated pattern is 5 bytes long */
