/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

/*
 * $Header: zdformat.h 1.1 86/04/23 $
 *
 * zdformat.h
 */

/* $Log:	zdformat.h,v $
 */

#define	HOWMANY(x, y)	(((x)+((y)-1))/(y))
#define	ROUNDUP(x, y)	((((x)+((y)-1))/(y))*(y))

#define TRUE		1
#define FALSE		0

#define	SUCCESS		1
#define	FAIL		0

/*
 * Tasks performed by this program.
 */
#define	FORMAT		1	/* Format disk */
#define REFORMAT	2	/* Reformat disk */
#define VERIFY		3	/* Verify (only) disk */
#define ADDBAD		4	/* add bad block(s) to bad block list */
#define	DISPLAY		5	/* print bad block list a/o mfg defect list */
#define	CLONEFMT	6	/* reformat cylinders as per bad block list */

/*
 * Display options
 */
#define	MFG_DEFECT	0x1	/* Print out mfg defect list */
#define	BAD_BLOCK	0x2	/* Print out bad block list */

/*
 * Format/verify defaults
 */
#define	NFULLPASS	3	/* No. of verify passes on entire range */
#define	NDEFECTPASS	45	/* no. of verify passes on tracks with spots */

/*
 * Header format.
 */
struct	hdr {
	u_char	h_type;		/* type of sector */
	u_char	h_flag;		/* see stand/zdc.h */
	u_short	h_cyl;		/* cylinder number */
	u_char	h_head;		/* track number */
	u_char	h_sect;		/* sector number */
};

/*
 * 1 per track in cylinder.
 */
struct track_hdr {
	int	t_free;			/* No. of unused spares on track */
	int	t_bad;			/* No. of defects to resolve on track */
	struct	hdr *t_hdr;		/* array of headers for track */
};

/*
 * 2 cylinder window.
 */
struct cyl_hdr {
	int	c_free;			/* No. of unused spares on cylinder */
	int	c_bad;			/* No. of defects to resolve on cyl */
	struct	track_hdr *c_trk;	/* array of track_hdrs */
};
extern struct cyl_hdr cyls[];

/*
 * Structure to hold bad blocks not resolved via the first pass.
 * These BZ_SNF entries are usually resolved in non-adjacent cylinders.
 * This is used by ADDBAD and to format disks where there can be more
 * errors in small cylinder group than spares to resolve.
 */
struct snf_list {
	struct	diskaddr snf_addr;
	caddr_t	snf_data;
};
extern struct snf_list snf_list[];
extern int snftogo;

#define	SNF_LIST_SIZE	256

/*
 * Addlist definition and size
 */
struct addlist {
	u_char		al_type;
	struct diskaddr al_addr;
};
#define	MAXADDBAD	64		/* Max no. to addbad at one time */
extern struct addlist addlist[];	/* Addlist for addbad */

extern int	startcyl;	/* starting cylinder */
extern int	lastcyl;	/* last cylinder */
extern int	verbose;	/* print interesting things */
extern int	fd;		/* file descripter for disk */
extern int	totspt;		/* total sectors per track (incl spare(s)) */
extern struct zdcdd *chancfg;	/* Channel configuration - drive descriptor */
extern struct bad_mfg	*mfg;	/* mfg defect list */
extern struct zdbad  *bbl;	/* bad block list */
extern struct zdbad  *newbbl;	/* new bad block list - built during format */
extern struct bz_bad *tobzp;	/* ptr to new list entry */
struct bz_bad *find_bbl_entry();
struct bz_bad *newbad();
int	bblcomp();
caddr_t	calloc();
char	*prompt();
int	scani();
