/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ifndef	lint
static	char	rcsid[] = "$Header: uipc_pipe.c 2.1 86/10/16 $";
#endif

/*
 * uipc_pipe.c
 *	Connect sockets to implement a Unix pipe
 */

/* $Log:	uipc_pipe.c,v $
 */

#include "../h/param.h"
#include "../h/systm.h"
#include "../h/mutex.h"	
#include "../machine/gate.h"
#include "../machine/intctl.h"	
#include "../h/mbuf.h"
#include "../h/protosw.h"
#include "../h/socket.h"
#include "../h/socketvar.h"
#include "../h/unpcb.h"

#define	PIPSIZ	4096

/*
 * Sneakily connect a pipe from wso to rso.
 * This will get cleaned up when socketpair is added.
 */
piconnect(wso, rso)
	struct socket *wso, *rso;
{
	/*** attaches unix domain pcb's to two sockets **/

/** Note that LOCKING is not required here since sockets (i.e. pipe)
 *	not known yet.
 */
	sotounpcb(wso)->unp_conn = sotounpcb(rso);
	sotounpcb(rso)->unp_conn = sotounpcb(wso);

	wso->so_snd.sb_hiwat = PIPSIZ;
	wso->so_snd.sb_mbmax = 2*PIPSIZ;
	wso->so_state |= SS_ISCONNECTED|SS_CANTRCVMORE;

	rso->so_rcv.sb_hiwat = 0;
	rso->so_rcv.sb_mbmax = 0;
	rso->so_state |= SS_ISCONNECTED|SS_CANTSENDMORE;

/*** now set up peer lock **/

	(void) m_free(dtom(rso->so_sopp));

	rso->so_sopp = wso->so_sopp;

	rso->so_sopp->sop_refcnt = 4;	/* 4 PEERS for Pipes **/

/** Now both rso and wso are locked by same lock to avoid peer update
 *	deadlock.
 */
	return (1);
}
