/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

#ifndef	lint
static	char	rcsid[] = "$Header: /usr/src/dynix.3.0.17/src/sys/i386/conf/RCS/conf_net.c,v 1.2 91/06/19 00:59:39 bruce Exp $";
#endif

/*
 *	Network binary config variables.
 */

#include "../h/param.h"
#include "../h/socket.h"
#include "../h/socketvar.h"
#include "../net/if.h"
#include "../net/route.h"
#include "../net/raw_cb.h"
#include "../netinet/tcp.h"
#include "../netinet/tcp_timer.h"
#include "../netinet/tcp_var.h"

/*
 * checksum option flags
 */

int	ipcksumo = 1;	/* generate checksum on output */
int	ipcksumi = 1;	/* check checksum on input  */

int	tcpcksumi = 1;	/* check checksums on input */
int	tcpcksumo = 1;	/* generate checksums on output */

int	udpcksumi = 1;	/* check udp checksum on input */
#ifdef NFS
/* int	udpcksumo = 0;	/* no udp checksum on output (for performance) */
int	udpcksumo = 1;	/* udp checksum on output (for safety) */
#else
int	udpcksumo = 1;	/* udp checksum on output (for safety) */
#endif NFS

/*
 * Initial mbuf and cluster sizes.  Used by ../sys/uipc_mbuf.c.
 */

int	mbinitbufs = 64*1024/CLBYTES;	/* pages of 128 byte mbufs */
int	mbinitcl = 200;			/* number of MCLBYTES mclusters */

/*
 *	max interface queue lengths - currently == 200 entries
 */

#ifndef IFQ_MAXLEN
#define IFQ_MAXLEN	200
#endif

int	ifqmaxlen =	 IFQ_MAXLEN;
int	raw_ifq_maxlen = IFQ_MAXLEN;
int	ipqmaxlen =	 IFQ_MAXLEN;

/*
 *	tcp config variables
 *	used by ../netinet/tcp_usrreq.c (externed in tcp_var.h)
 */

int	tcp_sendspace = 1024*4;	/* size of socket buffer window */
int	tcp_recvspace = 1024*4;

/*
 *	udp config variables
 *	used by ../netinet/udp_usrreq.c (externed in udp_var.h)
 */

int	udp_sendspace = 16384;	/* size of largest udp */
int	udp_recvspace = 32767;	/* size of recv buffer space */

/*
 * buffer space for raw sockets.
 */

int rawsndq = RAWSNDQ;
int rawrcvq = RAWRCVQ;

/*
 * used by promiscuous monitor to distinquish loopback packets
 */

u_char loopbackfakeaddr[6] = {0xfe, 0xed, 0xfa, 0xce, 0xbe, 0xef};

/*
 *	used by ../sys/uipc_socket.c
 */

int	somaxcon = SOMAXCONN;	/* max number of connections listen
				 * can queue (currently 5) */
/*
 *	used by ../sys/uipc_usrreq.c
 */

int	unp_sendspace = 1024*2;
int	unp_recvspace = 1024*2;

/*
 *	used by ../netinet/tcp_timer.c
 */

int	tcpnodelack = 0;
int	tcp_backoff[TCP_MAXRXTSHIFT+1] =
    { 1, 2, 4, 6, 8, 10, 15, 20, 30, 30, 30, 30, 30 };	

/*
 * default retransmit time 
 * until round trip time estimate is obtained
 */
int	tcp_default_rexmt = 3;		/* in seconds */

/*
 * Time To Live (hop count) for Tcp segments
 */
int	tcp_ttl = 50;
/*
 *	used by ../netinet/ip_input.c
 */

#ifndef	IPFORWARDING
#define	IPFORWARDING	1
#endif
#ifndef	IPSENDREDIRECTS
#define	IPSENDREDIRECTS	1
#endif

int	ipprintfs = 0;
int	ipforwarding = IPFORWARDING;
int	ipsendredirects = IPSENDREDIRECTS;

#ifndef SUBNETSARELOCAL
#define	SUBNETSARELOCAL	1
#endif

int subnetsarelocal = SUBNETSARELOCAL;

/*
 * if INBROADCAST == 0 then use 0 as default IP broadcast address
 * otherwise use all 1's
 */

int INBROADCAST = 0;

/*
 *	used by ../netinet/ip_output.c
 */

short	ip_allowbroadcast = 1;	/* allows user programs to use broadcast */

#ifndef	GATEWAY
#define RTHASHSIZ 8
#define	GATEWAY	0	/* do not send ICMP_UNREACH over one in_interface */
#else
#define RTHASHSIZ 64	/* gateways like more routes cached */
#endif

int	ipgateway = GATEWAY;
struct	mbuf *rthost[RTHASHSIZ];
struct	mbuf *rtnet[RTHASHSIZ];
int rthashsize = RTHASHSIZ;	/* used by netstat */

/*
 * APPLETALK config
 */

int kin_atalk_arp = 0;		/* Kinetics Appletalk Arp using net 0 IP addrs */
int ddpqmaxlen = IFQ_MAXLEN;
int ddp_sendspace = 2048;
int ddp_recvspace = 2048;
