$SYSTEM
      program pfactorial
C  Usage: pfac n
C  Computes n factorial (n!) using a parallel (but dumb) algorithm.
C  Line 29 contains an intentional error.

C  Shared common block:
      common /shmem/ factorial, lock, barrier
      integer*4 factorial, lock
      integer*1 barrier(10)

C  fork system call
      integer _fork

      character*8 argbuf
      integer*4 n, me

C  Get number from command line.
      call getarg (2, argbuf)
      read (argbuf, 50) n
 50   format (i8)
      if (n .lt. 1 .or. n .gt. 12) then
	  write (*,*) 'Number out of range.'
	  call fhalt (1)
      endif

C  Initialize the spinlock and barrier.
      call _p_init_lock (lock)
      call _p_finit_barrier(barrier, n)

C  Parent forks n kids, then waits for them to finish.
C  Each kid multiplies his id number into the product and exits.
      factorial = 1
      do 100 me = 1,n
      if (_fork() .eq. 0) then
C  I'm a kid.  Do my multiply, wait for all to finish, then exit.
	  call _p_lock (lock)
	  factorial = factorial * me
	  call _p_unlock (lock)
          call _p_wait_barrier (barrier)
	  call fhalt (0)
      endif
 100  continue

C  I'm the parent.  Wait for the kids; then print the result.
      call _p_wait_barrier (barrier)
      write (*,*) n, '! = ', factorial
      call fhalt (0)

      end
