/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987 Sequent Computer Systems, Inc.
 * All rights reserved
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */

	.file	"fpu387.s"
	.text
	.asciz	"$Header: fpu387.s 1.5 87/09/28 $"

/*
 * Routines for dealing with 387 80bit temporary format
 *
 * Using "stack model" compiler the stack is allways empty,
 * so the "fix up stack" instructions are not required.
 */

	.globl	_temp_387_code

/*
 * double t_to_d( ptr ) 
 * char *ptr;
 *	convert a 80bit temporary format to a double in %st(0)
 */
	.text
	.globl	_t_to_d
_t_to_d:
	pushl	%ebp
	movl	%esp,%ebp		# linkage for debugging
	movl	8(%ebp),%eax		# get single argument
	pushl	%eax			# arg on stack
	call	_temp_387_code		# decode 80 bit temp for type
	popl	%ecx			# clean up stack
	cmpl	$0,%eax			# make sure "good" floating point value
	jne	bad_387_value		# zero is ok to convert

	movl	8(%ebp),%eax		# get single argument
	fldt	(%eax)			# load temp into %st(0)
	leave
	ret				# return value is in %st(0)

bad_387_value:
	fldz				# put a zero in %st(0) [top of stack]
	leave
	ret				# return value is in %st(0)

/*
 * void d_to_t( value, ptr )
 * double value;
 * char *ptr;
 *	assign a double to ptr in 80 bit temporary format
 */
	.text
	.globl	_d_to_t
_d_to_t:
	pushl	%ebp
	movl	%esp,%ebp		# linkage for debugging
	movl	16(%ebp),%eax		# get destination
/	fstp	%st(0)			# pop 387 stack
	fldl	8(%ebp)			# get value into %st(0)
	fstpt	(%eax)			# store into destination (80 bits)
/	fldl	8(%ebp)			# fix up stack
	leave
	ret				# no explicit return value
