#!/bin/sh
# $Copyright:	$
# Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
# Sequent Computer Systems, Inc.   All rights reserved.
#  
# This software is furnished under a license and may be used
# only in accordance with the terms of that license and with the
# inclusion of the above copyright notice.   This software may not
# be provided or otherwise made available to, or used by, any
# other person.  No title to or ownership of the software is
# hereby transferred.

# $Header: mailbug.sh 2.4 90/01/04 $
PATH=/usr/ucb:/bin:/usr/bin
tmp=/tmp/mailbug.$$
COMPANY_NAME=/usr/lib/mailbug_co_name
PERSONAL_DATA=$HOME/.mailbug
trap 'rm -f $tmp; exit 1' 1 2 3
echo "=== Problem Tracking System bug report ===
Follow the instructions; press RETURN after entering each response."
case $USER in
	root )
		echo -n "Your login name: "
		read it
		echo "Really from: $it" >>$tmp
		;;
esac
if [ -f $COMPANY_NAME ]
then cat $COMPANY_NAME >>$tmp
else echo -n "Your Company/Organization name: "
     read it
     echo "Company: $it" >>$tmp
fi
if [ -f $PERSONAL_DATA ]
then cat $PERSONAL_DATA >>$tmp
else echo -n "Your full name: "
     read it
     echo "Full name: $it" >>$tmp
     echo -n "Your phone number: "
     read it
     echo "Phone number: $it" >>$tmp
fi
echo "Version: `cat /etc/versionlog`" >>$tmp
echo -n "Configuration: " >>$tmp
/etc/showcfg >>$tmp
echo -n "One line summary of bug? "
read sum
echo "Summary: $sum" >>$tmp
until
	echo -n \
"Severity:
	Critical	(prevents total use of system)
	Serious		(prevents use of affected portion)
	Normal		(workarounds difficult or unknown)
	Low		(workarounds known, but a nuisance)
	Enhancement	(a request for a new capability or feature)
	For Your Information
(initial letter is sufficient)? "
	read it
	case "$it" in
		[cC]* )
			it=Critical ;;
		[sS]* )
			it=Serious ;;
		[nN]* )
			it=Normal ;;
		[lL]* )
			it=Low ;;
		[eE]* )
			it=Enhancement ;;
		[fF]* )
			it=FYI ;;
		* )
			false ;;
	esac
do
	echo "(... please enter a choice ...)"
done
echo "Severity: $it" >>$tmp
until
	echo -n \
"System Type:
	Balance
	Symmetry
	All of the above
	Not applicable
(initial letter is sufficient)? "
	read it
	case "$it" in
		[bB]* )
			it=Balance ;;
		[sS]* )
			it=Symmetry ;;
		[aA]* )
			it=All ;;
		[nN]* )
			it='N/A' ;;
		* )
			false ;;
	esac
do
	echo "(... please enter a choice ...)"
done
echo "System Type: $it" >>$tmp
until
	echo -n \
"Category:
	Documentation
	Hardware
	Mechanical
	Software
	Other (or unidentified)
(initial letter is sufficient)? "
	read it
	case "$it" in
		[dD]* )
			it=Documentation ;;
		[hH]* )
			it=Hardware ;;
		[sS]* )
			it=Software ;;
		[mM]* )
			it=Mechanical ;;
		[oOuU]* )
			it=Other ;;
		* )
			false ;;
	esac
do
	echo "(... please enter a choice ...)"
done
echo "Category: $it" >>$tmp
case "$it" in
	Documentation )
		echo -n "Document Title? "
		read it
		echo "Document Title: $it" >>$tmp
		echo -n "Page Number? "
		read it
		echo "Page Number: $it" >>$tmp
		echo -n "Rev Number on Page? "
		read it
		echo "Rev Number: $it" >>$tmp
		echo "Description:" >>$tmp
		echo "Enter a description ... terminate with CTRL-D"
		sed 's/^/ /' >>$tmp
		echo "[End Description]" >>$tmp
		;;
	Hardware )
		echo -n "Type of hardware? "
		read it
		echo "Type: $it" >>$tmp
		echo -n "Part Number? "
		read it
		echo "Part Number: $it" >>$tmp
		echo -n "Revision? "
		read it
		echo "Revision: $it" >>$tmp
		echo -n "Serial Number? "
		read it
		echo "Serial Number: $it" >>$tmp
		echo "Description:" >>$tmp
		echo "Enter a description ... terminate with CTRL-D"
		sed 's/^/ /' >>$tmp
		echo "[End Description]" >>$tmp
		;;
	Mechanical )
		echo -n "Part? "
		read it
		echo "Type: $it" >>$tmp
		echo -n "Part Number? "
		read it
		echo "Part Number: $it" >>$tmp
		echo -n "Revision? "
		read it
		echo "Revision: $it" >>$tmp
		echo -n "Serial Number? "
		read it
		echo "Serial Number: $it" >>$tmp
		echo "Description:" >>$tmp
		echo "Enter a description ... terminate with CTRL-D"
		sed 's/^/ /' >>$tmp
		echo "[End Description]" >>$tmp
		;;
	Software )
		echo -n "Full pathname to suspected component
(press RETURN if unknown)? "
		read it
		if [ "x$it" != x -a -f "$it" ]
		then
			echo "Id: `id $it`" >>$tmp
		else
			echo "Id: unknown ($it)" >>$tmp
		fi
		echo "Description:" >>$tmp
		echo "Enter a description ... terminate with CTRL-D
(please include whatever steps are necessary to repeat the problem)"
		sed 's/^/ /' >>$tmp
		echo "[End Description]" >>$tmp
		;;
	Other )
		echo "Description:" >>$tmp
		echo "Enter a description ... terminate with CTRL-D"
		sed 's/^/ /' >>$tmp
		echo "[End Description]" >>$tmp
		;;
	* )
		# ooops!
		echo "mailbug botched .. category is $it" >>$tmp
		echo "mailbug botched .. please report it!"
		;;
esac
until
	echo -n \
"Now what:
	List bug report
	Edit it
	Send it
	Abort (and save it)
(initial letter is sufficient)? "
	read it
	case "$it" in
		[lL]* )
			${PAGER-more} $tmp
			false ;;
		[eE]* )
			trap ':' 1 2 3
			${EDITOR-vi} $tmp
			trap 'rm -f $tmp; exit 1' 1 2 3
			false ;;
		[sS]* )
			Mail -s "mailbug: $sum $USER" pts $USER <$tmp
			true ;;
		[aA]* )
			cp $tmp $HOME/mailbug$$
			echo "(Report saved in $HOME/mailbug$$)"
			true ;;
		* )
			echo "(... please enter a choice ...)"
			false ;;
	esac
do
	:
done
rm $tmp
