#ifndef lint
static char rcsid[] = "$Header: misc.c 2.3 87/08/06 $";
#endif

#include "crash.h"
#include <sys/param.h>
#include <sys/systm.h>
#include <sys/dir.h> 
#include <sys/user.h>
#include <sys/proc.h>
#include <sys/vm.h>
#include <sys/stat.h>
#include <machine/pte.h>
#include <machine/vmparam.h>
#include <machine/plocal.h>
#include <a.out.h>

long Etext;
int disrd;

cmdsum()
{
	register  struct  tsw	*tp;
	char lbuf[128];

	printf("Dynix Dump Analyzer -- Version %s of %s.\n\n", Version, Date);
	printf("available commands:\n");
	for(tp = t; tp->t_snm; tp++)
		if(tp->t_dsc)
			printf("%s\t%s\t%s\n", 
				*tp->t_snm == ' ' ? "" : sprintf(lbuf, "(%s)", tp->t_snm), tp->t_nm,tp->t_dsc);
	tok = 0;
}

nop(){}

char *
addr_str(addr)
{
	unsigned int off;
	char *symfound;
	static char buf[ MAXSTRLEN + 10 ];

	symfound = lookbyval(addr, &off);
	if (symfound && (off <= 0x1000)) {
		if( off )
			sprintf(buf, "%s+%#x", symfound, off);
		else
			sprintf(buf, "%s",symfound);
	} else
		sprintf(buf, "%#x", addr);
	return buf;
}

What()
{
	int  addr;
	char *arg;

	while((arg = token()) != NULL) {
		addr = atoi(arg);
		if ( err_atoi ) {
			printf("'%s', %s?\n", arg, err_atoi);
			continue;
		}
		printf("%s = %#x\n", addr_str(addr), addr);
	}
}

Vtop()
{
	int vaddr;
	int phys;
	char *arg;

	arg = token();
	vaddr = atoi(arg);
	phys = vtop(vaddr);
	printf("virt = %s, phys = %08#x\n", arg, phys);
}
	
vtop(vaddr)
int vaddr;
{
	int paddr;
	
#ifdef	i386
	if (vaddr < 8192)
		return vaddr;
#endif
	paddr = (int)((int *)Sysmap + (vaddr / NBPG));
	lseek(vmcorefd, paddr, 0);
	read(vmcorefd, &paddr, sizeof paddr);
#ifdef	ns32000
# define	PTBITS	0x1ff	/* 512 byte pages */
#endif
#ifdef	i386
# define	PTBITS	0xfff	/* 4096 byte pages */
#endif
	return (paddr & ~PTBITS) | (vaddr & PTBITS);
}

readv(vaddr, addr, nbytes)
{
	register int nbyt, nrd, n, p;

	nbyt = nbytes;
#if CRASH_DEBUG
	if (debug > 1)
		printf("readv(vaddr=%#x, addr=%#x, nbytes=%d)\n", vaddr, addr, nbytes);
#endif
	while( nbytes ) {
		p = vtop(vaddr);
		n = NBPG - vaddr % NBPG;
		nrd = nbytes > n ? n : nbytes;
/* Need to check for transfer crossing over etext */
		if (p < Etext) {	
			/* text of vmcore is trashed so read from /dynix */
			lseek(dynixfd, (long) p, 0);
			n = read(dynixfd, addr, nrd);
		} else {
			lseek(vmcorefd, (long) p, 0);
			n = read(vmcorefd, addr, nrd);
		}
		if( n != nrd )
			return -1;
		nbytes -= nrd;
		vaddr  += nrd;
		addr   += nrd;
	}
	return nbyt;
}

readp(paddr, addr, nbytes)
{
#ifdef	CRASH_DEBUG
	if (debug > 5)
		printf("readp(paddr=%#x, addr=%#x, nbytes=%d\n", paddr, addr, nbytes);
#endif
	lseek(vmcorefd, paddr, 0);
	return read(vmcorefd, addr, nbytes);
}

int	err_search;

unsigned int
search(sym)
char *sym;
{
	int val;

	err_search = 0;
	if( lookbysym(sym, &val) == FALSE ) {
		err_search = 1;
		return NULL;
	}
	return val;
}

getsysmap()
{
	Sysmap = (struct pte *)search("Sysmap");
	lseek(vmcorefd, Sysmap, 0);
	read(vmcorefd, &Sysmap, sizeof Sysmap);
}

int debug;

trace()
{
	char *c;

	c = token();
	if (c == NULL) {
		if (debug) 
			debug = 0;
		else
			debug = 1;
	} else 
		debug = atoi(c);
	printf("Debug trace set to %d\n", debug);
	tok = 0;
}

char *
nice_char(c)
	register char c;
{
	static char lbuf[4];
	char lb[4];

	lbuf[0] = 0;
	if (c == 0 || c == '\t') {
		sprintf(lbuf, "%c", c);
		return (lbuf);
	}
	if (c & 0200) {
		sprintf(lbuf, "M-");
		c &= 0177;
	}
	if (c < ' ')
		strcat(lbuf, sprintf(lb, "^%c", c+'@'));
	else if (c == 0177)
		strcat(lbuf, "^?");
	else
		strcat(lbuf, sprintf(lb, "%c", c));
	return(lbuf);
}

a_out(s)
	char *s;
{
	register n;
	struct exec x;
	struct stat sb;

	n = open(s, 0);
	if (n < 0)
		return (0);
	if (read(n, &x, sizeof x) != sizeof x) {
		close(n);
		return (0);
	}
	close(n);
	if (N_BADMAG(x))
		return FALSE;
	/* catch /dev/kmem here */
	if (stat(s, &sb) < 0 || (sb.st_mode & S_IFMT) != S_IFREG)
		return FALSE;
	Etext = x.a_text;
	return TRUE;
}

char *
user_cmd(u)
	register struct user *u;
{
	register i;
	register unsigned char *s;
	static char lbuf[3*MAXCOMLEN];

	s = (unsigned char *) u->u_comm;
	lbuf[0] = 0;
	for (i=0; i < MAXCOMLEN && s[i]; i++)
		strcat(lbuf, nice_char(s[i]));
	return lbuf;
}

Dis()
{
	char *arg;
	int addr, count, length;

	if((arg = token()) == NULL) {
		printf("symbol expected\n");
		return;
	}
	addr = atoi(arg);
	if ( err_atoi ) {
err1:		printf("'%s', %s?\n", arg, err_atoi);
		tok = 0;
		return;
	}
	if((arg = token()) == NULL) {
		count = 10;
		disrd = 0;
		goto doit;
	} else {
		count = atoi(arg);
		if ( err_atoi ) {
			goto err1;
		}
	}

	if ((arg = token()) == NULL)
		disrd = 0;	/* read virtual */
	else if (*arg == 'p')
		disrd = 1;	/* read physical */
	else if (*arg == 'v')
		disrd = 0;	/* read virtual */
doit:
	while( count -- > 0 ) {
#ifdef	ns32000
		char *p = (char *)dis32000(addr, &length);
#endif
#ifdef	i386
		char *p = (char *)dis386(addr, &length);
#endif
		printf("%-19s%s	", addr_str(addr), disrd ? "p" : "v");
		if( length ) {
			printf("%s\n", p);
			addr += length;
		} else {
			printf("%#0x\n", Disread(addr));
			addr++;
		}
	}
}

Disread(addr)
char *addr;
{
	unsigned char byte;

	if (disrd)
		readp(addr, &byte, sizeof byte);
	else
		readv(addr, &byte, sizeof byte);
	return( byte );
}
