#include	"crash.h"
#include	"sys/types.h"
#include	"sys/time.h"
#include	"sys/vnode.h"
#define KERNEL
#include	"sys/inode.h"
#undef KERNEL

struct inode *readinode(), *inode, *inodeNINODE;
int ninode;

struct	vnode *readvnode(), *rootdir;
struct	vnodeops *ufs_vnode, *dev_vnode;

inode_init()
{

	readv(search("inode"), &inode, sizeof inode);
	readv(search("inodeNINODE"), &inodeNINODE, sizeof inodeNINODE);
	readv(search("ninode"), &ninode, sizeof ninode);
}

vnode_init()
{

	readv(search("rootdir"), &rootdir, sizeof rootdir);
	readv(search("ufs_vnodeops"), &ufs_vnode, sizeof ufs_vnode);
	readv(search("dev_vnode_ops"), &dev_vnode, sizeof dev_vnode);

}

Inode()
{

	struct inode *ii, *i = inode;
	register int j;
	char *arg;
	int count, slt;

	if (live)
		readv(search("ninode"), &ninode, sizeof ninode);

	printf("SLT   ADDR     VNODE  MAJ MIN INUMB LINK UID  GID MCNT  MODE    FLAGS\n");
						
	if ((arg = token()) == NULL) {		/* print the works */
		for (j = ninode; j > 0; i++, j--) {
			printf("%-3d", ninode - j);
			prinode(i);
		}
	} else if (bcmp("0x", arg, 2) == 0) {/* inode address supplied */
		printf("%-3d",
		      (((struct inode *)atox(arg+2) - inode) / sizeof (struct inode))); 
		prinode((struct inode *)atox(arg+2));
	 } else {				/* selective print */
		slt = atoi(arg);
		i +=  slt;
		count = atoi(token());
		if (!count) count = 1;
		count = ((count + slt) > ninode ) ? (ninode - slt) : count;
		for (j = count; j > 0; i++, j--, slt++) {
			printf("%-3d", slt);
			prinode(i);
		}
	}	

}

Vnode()
{
	
	struct inode *ii, *i = inode;
	register int j;
	char *arg;
	int count, slt;

	printf("SLT  ADDR     INODE    CNT WCNT LCNT ECNT TYPE FS  EXT  FLAGS\n");

	if ((arg = token()) == NULL) {		/* print the works */
		for (j = ninode; j > 0; i++, j--) {
			printf("%-3d", ninode - j);
			prvnode(&i->i_vnode);
		}
	} else if (bcmp("0x", arg, 2) == 0) {/* vnode address supplied */
		printf(" ");
		prvnode(atoi(arg));
	} else {
		slt = atoi(arg);
		i +=  slt;
		count = atoi(token());
		if (!count) count = 1;
		for (j = count; j > 0; i++, j--, slt++) {
			printf("%-3d", slt);
			prvnode(&i->i_vnode);
		}
	}	
	
}	

prinode(ii)
register struct inode *ii;
{

	register struct inode	*i;
	register char	ch;

	if ((i = readinode(ii)) == NULL)
		return;

	printf(" %#6x %#6x %3.3o %3.3o %-5u %-4d %4-d %-4d %d",
		ii, &ii->i_vnode, major(i->i_dev), minor(i->i_dev), 
	        i->i_number, i->i_nlink, i->i_uid, i->i_gid, i->i_mutex.s_count);

	printf("%s%s%s%3o",
	i->i_mode & ISUID ? "u" : "-",
	i->i_mode & ISGID ? "g" : "-",
	i->i_mode & ISVTX ? "v" : "-",
	i->i_mode & 0777);

	switch(i->i_mode & IFMT) {
	case IFDIR: 
		ch = 'd'; 
		break;
	case IFCHR: 
		ch = 'c'; 
		break;
	case IFBLK: 
		ch = 'b'; 
		break;
	case IFREG: 
		ch = 'f'; 
		break;
	case IFIFO: 
		ch = 'p'; 
		break;
	case IFSOCK: 
		ch = 'S'; 
		break;
	case IFLNK: 
		ch = 'l'; 
		break;
	default:    
		ch = '-'; 
		break;
	}
	printf(" %c", ch);

	printf("%s%s%s%s\n",
	i->i_flag & IUPD ? " upd" : "",
	i->i_flag & IACC ? " acc" : "",
	i->i_flag & ICHG ? " chg" : "",
	i->i_flag & IFREE ? " free": "");

	return;

}

prvnode(vv)
register struct vnode *vv;
{

	register struct vnode *v;
	register char	ch;

	if ((v = readvnode(vv)) == NULL)
		return;

	printf(" %#6x %#6x  %-2u  %-2u   %-2u   ",
		vv, v->v_data, v->v_count, v->v_shlockc, v->v_exlockc);

	switch (v->v_type) {
	case VNON:
		ch = 'n';
		break;
	case VREG:
		ch = 'r';
		break;
	case VDIR:
		ch = 'd';
		break;
	case VBLK:
		ch = 'b';
		break;
	case VCHR:
		ch = 'c';
		break;
	case VLNK:
		ch = 'l';
		break;
	case VSOCK:
		ch = 's';
		break;
	case VBAD:
		ch = 'b';
		break;
	default:
		ch = '-';
		break;
	}

	printf(" %c", ch);

	if (v->v_op = ufs_vnode)
		printf("   ufs");
	else
		printf("   vfs");

	printf(" %s%s%s%s%s%s%s\n",
		v->v_flag & VROOT ? " vrt" : "",
		v->v_flag & VNBACCT ? " dev" : "",
		v->v_flag & VMOUNTING ? " mnt": "",
		v->v_flag & VBTAPE ? " tap": "",
		v->v_flag & VMAPPED ? " map": "",
		v->v_flag & VTEXT ? " txt": "",
		v->v_flag & VMAPSYNC ? " syn": "",
		v->v_flag & VNOLINKS ? " nol": "",
		v->v_exlockc ? " exl" : "",
		v->v_shlockc ? " shl" : "",
		(v->v_exsema.s_count || v->v_shsema.s_count) ? " lwt" : ""
	);
	
}	

struct inode *
readinode(ii)
struct inode *ii;
{

	static struct inode inodebuf;

	if (readv(ii, &inodebuf, sizeof inodebuf) != sizeof inodebuf) {
		printf("read error on inode table\n");
		return NULL;
	}
	return &inodebuf;

}


struct vnode *
readvnode(vv)
struct vnode *vv;
{

	static struct vnode vnodebuf;

	if (readv(vv, &vnodebuf, sizeof vnodebuf) != sizeof vnodebuf) {
		printf("read error on vnode\n");
		return NULL;
	}
	return &vnodebuf;

}

atox(p)
	register char *p;
{
	register int n = 0;

	for(; *p != '\0'; p++) {
		n <<= 4;
		if (*p >= 'a' && *p <= 'f') {
			n += (*p - 'a' + 0xa);
		} else if (*p >= 'A' && *p <= 'F') {
			n += (*p - 'A' + 0xa);
		} else {
			n += (*p - '0');
		}
	}
	return(n);
}

