#ifndef lint
static char rcsid[] = "$Header: stdio.c 2.1 86/05/07 $";
#endif

#include <stdio.h>
#include <signal.h>
#include <errno.h>

#undef bit
#define	bit(a)	(1<<(a))
#undef mask
#define mask(s) (1<<((s)-1))

extern FILE *filter;
extern int errno;

/*
 * Our special interface to printf routines
 * so we can catch output if to a popen filter.
 */

printf(fmt, args)
char *fmt;
{
	register FILE *f;
	int BIT;
	char localbuf[BUFSIZ];

	f = filter ? filter : stdout;
	if (f->_flag & _IONBF) {
		BIT = bit(f - _iob);
		setbuf(f, localbuf);
		_doprnt(fmt, &args, f);
		fflush(f);
		setbuf(f, NULL);
	} else
		_doprnt(fmt, &args, f);
	return(ferror(f)? EOF: 0);
}

/*
 * Our own copy of popen here so we can use
 * vfork.
 */

#define	tst(a,b)	(*mode == 'r'? (b) : (a))
#define	RDR	0
#define	WTR	1
static	int	popen_pid[_NFILE];

FILE *
popen(cmd,mode)
char	*cmd;
char	*mode;
{
	int p[2];
	register myside, hisside, pid;

	if(pipe(p) < 0)
		return NULL;
	myside = tst(p[WTR], p[RDR]);
	hisside = tst(p[RDR], p[WTR]);
	if((pid = vfork()) == 0) {
		/* myside and hisside reverse roles in child */
		close(myside);
		if (hisside != tst(0, 1)) {
			dup2(hisside, tst(0, 1));
			close(hisside);
		}
		execl("/bin/sh", "sh", "-c", cmd, 0);
		_exit(1);
	}
	if(pid == -1) {
		close(myside);
		close(hisside);
		return NULL;
	}
	popen_pid[myside] = pid;
	close(hisside);
	return(fdopen(myside, mode));
}

pclose(ptr)
FILE *ptr;
{
	register f, r;
	int status, omask;

	f = fileno(ptr);
	fclose(ptr);
	omask = sigblock(mask(SIGINT)|mask(SIGQUIT)|mask(SIGHUP));
	while((r = wait(&status)) != popen_pid[f] && r != -1 && errno != EINTR)
		/* do nothing */;
	if(r == -1)
		status = -1;
	sigsetmask(omask);
	return(status);
}
