#ifndef lint
static char rcsid[] = "$Header: stack.c 1.4 87/07/16 $";
#endif

#include "crash.h"

#include <sys/param.h>
#include <sys/systm.h>
#include <sys/dir.h> 
#include <sys/user.h>
#include <sys/proc.h>
#include <sys/vm.h>
#include <machine/pte.h>
#include <machine/vmparam.h>
#include <machine/engine.h>
#include <machine/plocal.h>
#include <machine/reg.h>
#include <machine/trap.h>

static	int	fp_length = 0;
static	int	*fp_tail = 0;
static	int	fp_offset = 0;

static	int	*kfp = 0;
static	int	usekfp = 0;
static	int	disreg = 0;

stack()
{
	register char *arg;
	register struct proc *p;
	int eng, n, didstack;

	eng = didstack = disreg = usekfp = 0;
	if ((arg=token()) == NULL) { /* "s" */
stackproc:
		if (live)
			readv(search("procmax"), &procmax, sizeof procmax);
		for (p = proc; p < procmax; p++) {
			fp_tail = 0;
			fp_length = 0;
			proctrace(p);
		}
		return;
	}
	while (arg != NULL) {
		/* display registers and fp if "-r" */
		if (strcmp(arg, "-r") == 0) {
			disreg = 1;
			arg = token();
			continue;
		}
		/* user selected kfp if "-f" */
		if (strcmp(arg, "-f") == 0) {
			usekfp = 1;
			arg = token();
			continue;
		}
		if (strcmp(arg, "-e") == 0) {
			eng = !eng;
			arg = token();
			if (arg == NULL)
				for (eng=0; eng < Nengine; eng++) {
					fp_tail = 0;
					fp_length = 0;
					didstack = 1;
					engtrace(eng);
				}
			continue;
		} else if (eng) {
			n = atoi(arg);
			if ( err_atoi ) {
				printf("'%s', %s\n", arg, err_atoi);
			} else {
				fp_tail = 0;
				fp_length = 0;
				didstack = 1;
				engtrace(n);
			}
		} else {
			fp_tail = 0;
			fp_length = 0;
			didstack = 1;
			proctrace(getproc(arg));
		}
		arg = token();
	}
	if (!didstack && (disreg || usekfp))
		goto stackproc;
}

static
Dmpstk()
{
	register char *arg;

	if ((arg = token()) == NULL) {
		printf("dump what stack?\n");
		return;
	}

	dmpstk(getproc(arg));
}

static
engtrace(n)
{
	struct engine *e, *v;
	struct ppriv_pages ppriv_pages;	/* physical address of local stuff */
	register struct priv_map *pm;
	register i,j;

	if (n < 0  || n >= Nengine) {
		printf("engine %d? (0..%d are valid)\n", n, Nengine-1);
		return;
	}
	e = &l_engine[n];
	v = &v_engine[n];
	if (live) 
		readv(v, e, sizeof (struct engine));
	j = readp(e->e_local, &ppriv_pages, sizeof ppriv_pages);
	if (j != sizeof ppriv_pages) {
		printf("engtrace: readp error (%d != %d)\n", j, sizeof ppriv_pages);
		return;
	}
	pm = (struct priv_map *)ppriv_pages.pp_pmap;
	for (j=0; j < UPAGES; j++) {
		i = readp(PTETOPHYS(pm->pm_uarea[j]), (char *) ppriv_pages.pp_uarea[j], NBPG);
		if (i != NBPG) {
			printf("engtrace: readp error (%d != %d)\n", i, NBPG);
			return;
		}
	}
#if CRASH_DEBUG
	if (debug > 2) {
		for (j=0; j < (UPAGES*NBPG)/sizeof (int); j++) {
			if ((j & (8-1)) == 0 || j==0) printf("%s%08x", j ? "\n" : NULL, VA_UAREA + j * sizeof (int));
			printf(" %08x", ((int *)ppriv_pages.pp_uarea)[j]);
		}
		printf("\n");
	}
#endif
	printf("\n*** Engine %d ***\n", n);
	utrace((struct user *)ppriv_pages.pp_uarea, 0);
}

static
proctrace(pp)
	struct proc *pp;	/* virtual address of proc entry */
{
	register struct user *ret;
	struct	proc	p;
	int	use_u_sp;

	if (pp == NULL)
		return;
	ret = getuarea(pp);
	if (ret == NULL) return 0;
	if (ret == (struct user *) -1) {
		printf("bad read of Uarea\n"); 
		return -1;
	}
	if (ret == (struct user *) SWAPPED) { 
		printf("process is swapped\n"); 
		return -1; 
	}
#if CRASH_DEBUG
	if (debug > 2) {
		register int j;
		for (j=0; j < (UPAGES*NBPG)/sizeof (int); j++) {
			if ((j & (8-1)) == 0 || j==0) printf("%s%08x", j ? "\n" : NULL, VA_UAREA + j * sizeof (int));
			printf(" %08x", ((int *)ret)[j]);
		}
		printf("\n");
	}
#endif
	/*
	 * If process anything but running on a processor, 
	 * find frame pointer from u.u_sp.
	 */

	printf("\n*** Proc slot %d ***\n", pp - proc);

	if (readv(pp, &p, sizeof (struct proc)) == sizeof (struct proc)
	&& (p.p_stat && p.p_stat != SONPROC))
		use_u_sp = 1;
	else
		use_u_sp = 0;
	utrace(ret, use_u_sp);
}

static
dmpstk(pp)
	struct proc *pp;
{
	register struct user *ret;
	register int j;

	if (pp == NULL)
		return;

	ret = getuarea(pp);
	if (ret == (struct user *) -1) {
		printf("bad read of Uarea\n");
		return -1;
	}

	if (ret == (struct user *) SWAPPED) {
		printf("process is swapped\n");
		return -1;
	}

	printf("*** Proc slot %d stack dump ***\n", pp - proc);

	for (j=0; j < (UPAGES*NBPG)/sizeof (int); j++) {
		if ((j & (8-1)) == 0 || j==0) printf("%s%08x", j ? "\n" : NULL, VA_UAREA + j * sizeof (int));
		printf(" %08x", ((int *)ret)[j]);
	}
	printf("\n");
}

static
utrace(u, use_u_sp)
	register struct user *u;
	int	use_u_sp;		/* derive fp from u_sp ?? */
{
	register  int *sp;
	int *fp, *guessfp;
	int *top, *bot;

	fp_offset = (VA_UAREA - (int)u);
	sp = (int *)(u->u_sp - fp_offset);

	top = (int *)(VA_UAREA + (UPAGES*NBPG) - fp_offset);
	bot = (int *)((int)top - (UPAGES*NBPG) + sizeof(struct user) + 32);

	if (debug) 
printf("(bottom %#x, top %#x)\n", (int)bot+fp_offset, (int)top+fp_offset);
	if (usekfp && (kfp != (int *)0)) {
		guessfp = (int *)((int)kfp - (int)fp_offset);
	 } else if (usekfp && (kfp == 0)) {
		printf("bad kfp\n");
		return;
	} else if (use_u_sp) {
		/*
		 * Stack frame when process is sleeping or stopped is
		 * u_sp -> EBP, ret PC.  386/implementation specific.
		 */
		guessfp = sp;
	} else
		guessfp = (int *) (scanfp(top, bot) - fp_offset);

#if CRASH_DEBUG
	if (debug > 1) 
		printf(">> utrace: fp_offset %#x, sp %#x, fp %#x, guessfp %#x, top %#x, bot %#x\n", 
			fp_offset, sp, fp, guessfp, top, bot);
#endif

	/* bad u_sp and scanfp failed */
	if ((int)guessfp+fp_offset == 0) {
		printf("no reasonable trace possible\n");
		return;
	}
	printstacktrace(guessfp, "unknown", top, bot);
}

static
scanfp(top, bot)
	int *bot, *top;
{
	fpsearch(top, bot, 0);
	return (int) fp_tail;
}

static
fpsearch(top, bot, depth)
	int *top, *bot;
{
	register int *i, *me;

	if (depth > (UPAGES*NBPG)/sizeof (int *)) {
		printf("fpsearch: recursion detected\n");
		return;
	}
	if (depth == 0) { /* top level */
		for (i=top-1; i >= top-48; i--) {
			me = (int *)(*i - fp_offset);
			if (me >= bot && me <= top)
				fpsearch(me, bot, depth+1);
		}
	} else {	/* looking for links */
		for (i=top-1; i >= bot; i--) {
			me = (int *)(*i - fp_offset);
			if (me == top) { /* found a link */
				if (depth > fp_length) {
					fp_length++;
					fp_tail = (int *)((int)i + fp_offset);
				}
				/* the divine recurse */
				fpsearch(i, bot, depth+1);
			}
		}
	}
}

/*
 * getregs()
 *	Look at at call frame for a given procedure, and determine
 *	how many (if any) register variables, and return their values.
 *
 * Assumes register order is %edi, %esi, %ebx.
 *
 * Returns # register variables, and values in regs[].
 */

/*
 * proc_entry[]:	Binary for "pushl %ebp; movl %esp, %ebp"
 * subl_byte_esp[]:	Binary for "subl $n, %esp" where n fits in a byte.
 * subl_long_esp[]:	Binary for "subl $n, %esp" where n fits in a long.
 * push_regs[]:		Binary for "pushl %edi; pushl %esi; pushl %ebx"
 */

static	char	*regname[] = { "edi", "esi", "ebx" };

static	unsigned char	proc_entry[] = { 0x55, 0x8b, 0xec };
static	unsigned char	subl_byte_esp[] = { 0x83, 0xec };
static	unsigned char	subl_long_esp[] = { 0x81, 0xec };
static	unsigned char	push_regs[] = { 0x57, 0x56, 0x53 };

static
getregs(sym, fp, regs)
	char	*sym;		/* entry symbol */
	int	*fp;		/* adjusted frame pointer for "sym" call */
	int	*regs;		/* array of registers to fill out */
{
	register unsigned char *ip;
	register int	i;
	unsigned int	val;
	unsigned char	instr[12];

	if (!lookbysym(sym, &val)
	||  readv(val, instr, sizeof(instr)) != sizeof(instr))
		return(0);

	/*
	 * If not standard procedure entry, assume no register variables.
	 */

	if (bcmp(instr, proc_entry, sizeof(proc_entry)) != 0)
		return(0);

	/*
	 * Skip a "subl $n, %esp" instruction (allocates locals before
	 * push registers), if one exists.
	 */

	ip = &instr[sizeof(proc_entry)];
	if (bcmp(ip, subl_byte_esp, sizeof(subl_byte_esp)) == 0) {
		ip += sizeof(subl_byte_esp);	/* skip to immediate */
		fp -= (*ip / 4);		/* adjust fp from immediate */
		ip += 1;			/* skip single byte immediate */
	} else if (bcmp(ip, subl_long_esp, sizeof(subl_long_esp)) == 0) {
		ip += sizeof(subl_long_esp);	/* skip to immediate */
		fp -= (*(long *)ip / 4);	/* adjust fp from immediate */
		ip += 4;			/* skip 4-byte immediate */
	}

	/*
	 * The next bytes of code push the registers (if any).
	 */

	for (i = 0; i < sizeof(push_regs); i++) {
		if (*ip++ != push_regs[i])
			break;
		regs[i] = *--fp;
	}

	return(i);
}

/*
 * printstacktrace()
 *	Print a stack trace, optionally with register variables.
 *
 * This could be augmented with more smarts about syscalls and locore
 * entries.
 */

static
printstacktrace(fp, whence, top, bot)
	register int *fp;		/* frame pointer of current frame */
	char	*whence;		/* from where we was called */
	int	*top, *bot;		/* range of stack values */
{
	int *newfp = (int *)(fp[0]);	/* frame pointer of next frame */
	int *oldpc = (int *)(fp[1]);	/* pc this frame returns to */
	int *oldap = (int *)(&fp[2]);	/* point to first argument */
	int  nargs = 0;			/* number of arguments passed */
	int prev_instr;
	char buft[100];
	unsigned char offset[sizeof(int)];
	int i;

	/*
	 * Get the instruction following call (at ret pc).
	 */

	readv(oldpc, &prev_instr, sizeof prev_instr);

	/*
	 * determine number of arguments from:
	 *	stack pointer subtract instruction 
	 *	or pop into register
	 */

#define POP_ECX           0x59  /* opcode for 386 'popl %ecx' instruction */
#define ADDLIMM8        0xc483  /* opcode for 386 'addl $imm8' instruction */
#define ADDLIMM32       0xc481  /* opcode for 386 'addl $imm32' instruction */

	if ((int)oldpc < Etext) {
		if ((prev_instr & 0xff) == POP_ECX) {
			nargs = 1;
        	} else if ((prev_instr & 0xFFFF) == ADDLIMM8) {
			nargs = ((prev_instr >> 16) & 0xff) / 4;
		} else if ((prev_instr & 0xFFFF) == ADDLIMM32) {
			readv(oldpc+2, offset, sizeof(offset));
			nargs = (offset[0] >> 24) | (offset[1] >>  8) | 
			        (offset[2] <<  8) | (offset[3] << 24);
		}
	}

	if (nargs > 6)		  /* sanity */
		nargs = 6;

	/*
	 * Figure procedure we're in from data below on the stack (eg, whence
	 * argument), and set up `whence' for next iteration (from "oldpc").
	 * Print arguments.
	 */

	strcpy(buft, whence);
	if (rindex(buft, '+'))
		*(char *)rindex(buft, '+') = '\0';
	printf("%s(", buft);
	while (nargs) {
		printf("%#x", *oldap++);
		if( --nargs )
			printf(", ");
	}
	if ((long)oldpc > Etext) {
		printf(") from unknown (%#x)\n", oldpc);
		whence = "unknown";
	} else {
		printf(") ");
		if (debug) printf("[fp=%#x] ", (int)fp+fp_offset);
		whence = addr_str(oldpc);
		printf("from %s\n", whence);
	}

	/*
	 * If in a "panic" frame, dump registers at time of panic.
	 * Else if looking at registers, dump them from current frame.
	 */

	if (strcmp("_panic", buft) == 0) {
		/*
		 * If panic() entry changes, so must this.
		 */
		int	*eax = fp - 8;
		printf("\t[eax=%x ebx=%x ecx=%x edx=%x esi=%x edi=%x] fp=%x\n",
				eax[EAX], eax[EBX], eax[ECX],
				eax[EDX], eax[ESI], eax[EDI],
				(int)fp + fp_offset);
	} else if (disreg) {
		int	regs[3];
		int	nregs;
		if (nregs = getregs(buft, fp, regs)) {
			printf("\t[");
			for (i = 0; i < nregs; i++) {
				if (i != 0) printf(" ");
				printf("%s=%#x", regname[i], regs[i]);
			}
			printf("] fp = %#x\n",(unsigned int)fp+fp_offset);
		}
	}

	if ((int)fp == ((int)top - 15*4)) {
		printf("from \"%s\", user pc %#x\n", user_cmd((struct user *)((int)top-(UPAGES*NBPG))), fp[10]);
		return;
	}

	newfp = (int *)((int)newfp - fp_offset);
	if (newfp <= top && newfp > fp && newfp >= bot)
		printstacktrace(newfp, whence, top, bot);
	else if (((int)top - (int)newfp) > 15*4)
		printf("unable to continue  [newfp=%#x]\n", (int)newfp+fp_offset);
}

Kfp()
{
	register char *arg;

	if ((arg = token()) == NULL)
		printf("kfp = %08#x\n", kfp);
	else 
		kfp = (int *)atoi(arg);
}

get_locore()
{
	extern int end_locore, start_locore;

	start_locore = search("_bin1int");
	end_locore = search("sys_copy_err");
	if (end_locore == 0 || start_locore == 0)
		printf("Warning: locore symbols out of date\n");
}
