/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 */


/*
 * ident	"$Header: zdformat.h 1.3 89/09/12 $"
 * zdformat.h
 */

/* $Log:	zdformat.h,v $
 */


/*
 * Miscellaneous
 */
#define TRUE		1
#define FALSE		0
#define	SUCCESS		1
#define FAIL		0

/*
 * Defines internal to zd formatter subsytem
 */
#define Z_FORMAT	1		/* zd format */
#define Z_REFORMAT	2		/* zd reformat */
#define Z_CLONEFORMAT	3		/* zd clone format */
#define Z_ADDBAD	4		/* zd addbad */
#define Z_VERIFY	6		/* zd verify */
#define Z_ADDMFG	7		/* zd addmfg */

/*
 * Functions which require B_OVERWRITE to be set if the disk
 * has a valid VTOC
 */
#define ZD_OVERWRITES	(FORMAT|REFORMAT|REFORMAT_MFG|VERIFY)

/*
 * ZDBYTESPT - total number of bytes per track
 * ZDMAXBAD  - maximum number of bad blocks allowed on disk
 */
#define ZDBYTESPT(c)	((((c)->zdd_sectors + (c)->zdd_spare) \
			* (c)->zdd_sector_bc) + (c)->zdd_runt)
#define ZDMAXBAD(c)	((((c)->zdd_sectors - ZDD_NDDSECTORS) / 2) \
			 << DEV_BSHIFT)

/*
 * Macros
 */
#define	HOWMANY(x, y)	(((x)+((y)-1))/(y))
#define	ROUNDUP(x, y)	((((x)+((y)-1))/(y))*(y))

/*
 * The controller and device number formatted as they
 * would be for opening device as a boot device. 
 */ 
#define ZD_BOOTNUM(c, d)   (((c) << 4) | (d))

/*
 * Format/verify defaults
 */
#define	NFULLPASS	3	/* No. of verify passes on entire range */
#define	NDEFECTPASS	45	/* no. of verify passes on tracks with spots */
#define PASSMAX		150	/* maximum passes */

/*
 * Header format.
 */
struct	hdr {
	u_char	h_type;		/* type of sector */
	u_char	h_flag;		/* see stand/zdc.h */
	ushort	h_cyl;		/* cylinder number */
	u_char	h_head;		/* track number */
	u_char	h_sect;		/* sector number */
};

/*
 * 1 per track in cylinder.
 */
struct track_hdr {
	int	t_free;			/* No. of unused spares on track */
	int	t_bad;			/* No. of defects to resolve on track */
	struct	hdr *t_hdr;		/* array of headers for track */
};

/*
 * 2 cylinder window.
 */
struct cyl_hdr {
	int	c_free;			/* No. of unused spares on cylinder */
	int	c_bad;			/* No. of defects to resolve on cyl */
	struct	track_hdr *c_trk;	/* array of track_hdrs */
};
extern struct cyl_hdr cyls[];

/*
 * Structure to hold bad blocks not resolved via the first pass.
 * These BZ_SNF entries are usually resolved in non-adjacent cylinders.
 * This is used by ADDBAD and to format disks where there can be more
 * errors in small cylinder group than spares to resolve.
 */
struct snf_list {
	struct	diskaddr snf_addr;
	caddr_t	snf_data;
};
extern struct snf_list snf_list[];
extern int snftogo;

#define	SNF_LIST_SIZE	256

/*
 * Addlist definition and size
 */
struct addlist {
	u_char		al_type;
	struct diskaddr al_addr;
};
#define	MAXADDBAD	64		/* Max no. to addbad at one time */
extern struct addlist addlist[];	/* Addlist for addbad */

extern int	startcyl;	/* starting cylinder */
extern int	lastcyl;	/* last cylinder */
extern int	totspt;		/* total sectors per track */
extern int	fullpasses;	/* # of full verify passes */
extern int	defectpasses;	/* # of defect verify passes */
extern struct zdcdd *chancfg;	/* Channel configuration - drive descriptor */
extern struct bad_mfg	*mfg;	/* mfg defect list */
extern struct zdbad  *bbl;	/* bad block list */
extern struct zdbad  *newbbl;	/* new bad block list - built during format */
extern struct bz_bad *tobzp;	/* ptr to new list entry */
struct bz_bad *find_bbl_entry();
struct bz_bad *newbad();
int	bblcomp();

struct bad_umfg {
	short	umfg_cyl;
	char	umfg_track;
	char	umfg_sect;
	struct def {
		short umfg_pos;
		short umfg_len;
	} def[4];
};
