%{
/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987 Sequent Computer Systems, Inc.
 * All rights reserved
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 *
 */

%}
%token <intval> kREAL kINTEGER kLOGICAL kDOUBLEPRECISION kCOMPLEX kCHARACTER
%token <intval> kREAD kWRITE kOPEN kCLOSE kINQUIRE kBACKSPACE 
%token <intval> kPRINT kSAVE kENDDO kENDFILE kREWIND kFORMAT
%token <intval> kIMPLICIT kPROGRAM kDO kCALL kCONTINUE kSTOP kENTRY kDOWHILE
%token <intval> kINTRINSIC kEXTERNAL kGOTO kTO kPAUSE kASSIGN kENDIF kELSE kTHEN
%token <intval> kDIMENSION kEQUIVALENCE kDATA kIF kCOMMON kRETURN kBLOCKDATA 
%token <intval> kFALSE kTRUE ')' '(' 
%token <dptr> kDCONST kRCONST
%token <intval> kNL kPARAMETER kEND kSUBROUTINE kFUNCTION kICONST 
%token <cptr> kHCONST kSCONST 
%token <table> kID 
%token <intval> kNONE kENCODE kDECODE kDEFINEFILE kFIND
%token <intval> kDOACROSS kCHUNK kLOCAL kUNROLL kSHARE kLASTLOCAL kLOCKS
%token <intval> kORDER kENDORDER kREDUCTION kREENTRANT kLOCK kUNLOCK
%token <intval> kBYTE kAUTOMATIC kVOLATILE kOPTIONS kNAMELIST kDOUBLECOMPLEX
%left <intval> ','
%nonassoc <intval> '='
%left <intval> kEQV kNEQV
%left <intval> kOR 
%left <intval> kAND 
%nonassoc <intval> kNOT
%nonassoc <intval> kEQ kNE kGT kLT kLE kGE
%left <intval> '+' '-' 
%left <intval> '*' '/' kCONCAT 
%right <intval> kSTARSTAR
%type <expr> exp arg arglist arglistplus
%type <table> constant type bound arraydeclaror  boundlist formallist label
%type <table> lvalue
%type <intval> letterbound letterlist
%type <listptr> idlist staridlist
%type <doptr> dohead
%type <slices> slicelist slice triplelist
%type <triples> triple
%{
#include <stdio.h>
#include "lex.h"
#include "symbol.h"
#include "ic.h"
#include "parser.h"
extern struct lexcontext *lexbase, parsercontext, keychkcontext;
#define YYMAXDEPTH 500
static struct tentry *decltype;
struct doacross *dotab = 0;
extern int reentrant;
%}
%%
program:	modulelist
	|	label assignment
	|	label kFUNCTION kID '(' formallist ')'
	|	label kFUNCTION kID '(' ')'
	;

modulelist:	module
	|	modulelist module
	|	modulelist label kOPTIONS options kNL
	|	label kOPTIONS options kNL
	;

module:		label kPROGRAM proghead kNL body    
	|	label kSUBROUTINE subhead kNL body
	|	label kBLOCKDATA blockid kNL specstmts label kEND kNL {doend();}
	|	label kBLOCKDATA blockid kNL label kEND kNL {doend();}
	|	label kBLOCKDATA blockid kNL impstmts label kEND kNL {doend();}
	|	label funhead kNL body
	|	mainstmts kEND kNL			{doend();}
	|	label kNL
	;

proghead:	kID			{newunit($1,voidtype);}
	;

blockid:	kID
	|
	;

subhead:	kID '(' formallist ')'	{newunit($1,newfuntype($3,voidtype));}
	|	kID		{newunit($1,newfuntype(voidtype,voidtype));}
	|	kID '(' ')'	{newunit($1,newfuntype(voidtype,voidtype));}
	;

funhead: 	type kFUNCTION kID '(' formallist ')' 
					{newunit($3,newfuntype($5,$1));}
	|	type kFUNCTION kID '(' ')' 
					{newunit($3,newfuntype(voidtype,$1));}
	|	kFUNCTION kID '(' formallist ')' 
					{newunit($3,newfuntype($4,0));}
	|	kFUNCTION kID '(' ')' 	{newunit($3,newfuntype(voidtype,0));}
	;

formallist:	kID			{$$=startformal($1);}
	|	'*'			{$$=startformal(0);}
	|	formallist ',' kID	{$$=addformal($1,$3);}
	|	formallist ',' '*'	{$$=addformal($1,0);}
	;

label:		kICONST			{$$=deflabel($1,yydbinfo[1]);}
	|				{$$=0;}
	;


staridlist:	kID			{$$=idcons($1,0);}
	|	idlist ',' kID		{$$=idcons($3,$1);}
	|	'*' kID			{$$=idcons($2,0);}
	|	idlist ',' '*' kID	{$$=idcons($4,$2);}
	;

idlist:		kID			{$$=idcons($1,0);}
	|	idlist ',' kID		{$$=idcons($3,$1);}
	;

body:		bodystmts kEND kNL 			{doend();}
	|	bodystmts kENTRY subhead kNL body
	;

mainstmts:	mainspecstmts execstmts label	
	|	execstmts label
	|	mainspecstmts label
	|	impstmts execstmts label
	|	label
	;

mainspecstmts:	label specstmt	kNL			{firststmt();}
	|	label kFORMAT '(' fmtlist ')' kNL	{firststmt();}
	|	label kDATA datalists kNL		{firststmt();}
	|	label assignment kNL		{firststmt();endexec($1);}
	|	impstmts label specstmt	kNL		{firststmt();}
	|	impstmts label kFORMAT '(' fmtlist ')' kNL	{firststmt();}
	|	impstmts label kDATA datalists kNL	{firststmt();}
	|	impstmts label assignment kNL	{firststmt();endexec($2);}
	|	mainspecstmts label specstmt kNL	
	|	mainspecstmts label kFORMAT '(' fmtlist ')' kNL	{firststmt();}
	|	mainspecstmts label kDATA datalists kNL	{firststmt();}
	|	mainspecstmts label assignment kNL	{firststmt();endexec($2);}
	|	mainspecstmts label kIMPLICIT implist kNL
	|	mainspecstmts error kNL			{yyerrok;}
	;

bodystmts:	specstmts execstmts label
	|	execstmts label
	|	specstmts label
	|	impstmts execstmts label
	|	impstmts label
	|	label
	;

impstmts:	label kIMPLICIT implist kNL
	|	impstmts label kIMPLICIT implist kNL
	|	impstmts error kNL			{yyerrok;}
	;

specstmts:	impstmts label specstmt	kNL		{firststmt();}
	|	impstmts label kFORMAT '(' fmtlist ')' kNL	{firststmt();}
	|	impstmts label kDATA datalists kNL	{firststmt();}
	|	impstmts label assignment kNL	{firststmt();endexec($2);}
	|	label specstmt	kNL			{firststmt();}
	|	label kFORMAT '(' fmtlist ')' kNL	{firststmt();}
	|	label kDATA datalists kNL	{firststmt();}
	|	label assignment kNL	{firststmt();endexec($1);}
	|	specstmts label specstmt kNL		
	|	specstmts label kFORMAT '(' fmtlist ')' kNL	{firststmt();}
	|	specstmts label kDATA datalists kNL	{firststmt();}
	|	specstmts label assignment kNL	{firststmt();endexec($2);}
	|	specstmts label kIMPLICIT implist kNL
	|	specstmts error kNL			{yyerrok;}
	;

specstmt:	type iddimlist 
	|	kPARAMETER '(' parmlist ')'
	|	kPARAMETER  parmlist
	|	kDIMENSION dimlist 
	|	kINTRINSIC idlist 
	|	kEXTERNAL staridlist 
	|	kEQUIVALENCE eqlist 
	|	kCOMMON cblist 
	|	kSAVE savelist 
	|	kSAVE 
	|	kREENTRANT 		{reentrant = 1;}
	|	kNAMELIST namelist
	|	kAUTOMATIC savelist	{reentrant = 1;}
	|	kAUTOMATIC		{reentrant = 1;}
	|	kVOLATILE savelist
	;

options:	'/' kID
	|	'/' kID '=' kID
	|	'/' kID ',' options
	|	'/' kID '=' kID ',' options
	;

parmlist:	kID '=' exp 			{parmlist($1,$3);}
	|	parmlist ',' kID '=' exp	{parmlist($3,$5);}
	;

saveitem:	'/' kID '/'
	|	kID
	;

savelist:	saveitem
	|	savelist ',' saveitem
	;

iddimlist:	iddim			{lexbase->hconok = 1;}
	|	iddimlist ',' iddim
	|	iddim {lexbase->hconok = 1;} '/' dvalues '/'
	|	iddimlist ',' iddim '/' dvalues '/'
	;

iddim:		kID				{dotype($1,decltype);}
	|	kID '*' kICONST			
			{dotype($1,maketype(decltype->x.type.elemtype,$3));}
	|	kID '*' '(' exp ')'		
			{dotype($1,maketype(decltype->x.type.elemtype,
				intcon($4)));}
	|	kID '*' '(' '*' ')'		
			{dotype($1,maketype(decltype->x.type.elemtype,0));}
	|	kID arraydeclaror 		
			{dotype($1,addbasetype($2,decltype));}
	|	kID arraydeclaror '*' kICONST
			{dotype($1,addbasetype($2,
			maketype(decltype->x.type.elemtype,$4)));}
	|	kID arraydeclaror '*' '(' exp ')'
			{dotype($1,addbasetype($2,
			maketype(decltype->x.type.elemtype,intcon($5))));}
	|	kID arraydeclaror '*' '(' '*' ')'
			{dotype($1,addbasetype($2,
			maketype(decltype->x.type.elemtype,0)));}
	;

arraydeclaror:	'(' boundlist ')'		{$$ = $2;}
	|	'(' boundlist ',' '*' ')' 	
				{$$ = newarraytype($2,bound(expint(1),0));}
	|	'(' boundlist ',' exp ':' '*' ')'	
				{$$ = newarraytype($2,bound($4,0));}
	|	'(' '*' ')'    	{$$ = newarraytype(0,bound(expint(1),0));}
	|	'(' exp ':' '*' ')'	{$$ = newarraytype(0,bound($2,0));}
	;

boundlist:	bound				{$$ = newarraytype(0,$1);}
	|	boundlist ',' bound		{$$ = newarraytype($1,$3);}
	;

bound:		exp				{$$ = bound(expint(1),$1);}
	|	exp ':' exp			{$$ = bound($1,$3);}
	;

dimlist:	kID arraydeclaror		{dodim($1,$2);}
	|	dimlist ',' kID arraydeclaror	{dodim($3,$4);}
	;

implist:	type '(' letterlist ')'			
			{impset($1,$3);lexbase->keyok = 1;}
	|	implist ',' type '(' letterlist ')'	
			{impset($3,$5);lexbase->keyok = 1;}
	|	kNONE 	{impnone();}
	;

letterlist:	letterbound
	|	letterlist ',' letterbound	{$$ = $1 | $3;}
	;

letterbound:	kID '-' kID			{$$=letterbound($1,$3);}
	|	kID 				{$$=letterbound($1,$1);}
	;

eqlist:		'(' eqaddrs ')'
	|	eqlist ',' '(' eqaddrs ')'
	;

eqaddrs:	eqaddr
	|	eqaddrs ',' eqaddr
	;

eqaddr:		kID
	|	kID '(' constexplist ')'
	|	kID '(' constexplist ')' '(' sbound ':' sbound ')'
	|	kID '(' sbound ':' sbound ')'
	;

type:		kINTEGER		{$$=decltype=inttype;}
	|	kINTEGER '*' kICONST	{$$=decltype=maketype(TYINT,$3);}
	|	kREAL			{$$=decltype=realtype;}
	|	kREAL '*' kICONST	{$$=decltype=maketype(TYREAL,$3);}
	|	kLOGICAL		{$$=decltype=logtype;}
	|	kLOGICAL '*' kICONST	{$$=decltype=maketype(TYLOG,$3);}
	|	kCOMPLEX		{$$=decltype=complextype;}
	|	kCOMPLEX '*' kICONST	{$$=decltype=maketype(TYCOMPLEX,$3);}
	|	kDOUBLEPRECISION	{$$=decltype=doubletype;}
	|	kDOUBLEPRECISION '*' kICONST	
					{$$=decltype=maketype(TYREAL,$3);}
	|	kDOUBLECOMPLEX		{$$=decltype=maketype(TYCOMPLEX,16);}
	|	kBYTE			{$$=decltype=maketype(TYLOG,1);}
	|	kCHARACTER		{$$=decltype=chartype;}
	|	kCHARACTER '*' kICONST	{$$=decltype=maketype(TYUSCHAR,$3);}
	|	kCHARACTER '*' '(' '*' ')'	
					{$$=decltype=maketype(TYUSCHAR,0);}
	|	kCHARACTER '*' '(' exp ')'	
				{$$=decltype=maketype(TYUSCHAR,intcon($4));}
	;

datalists:	daddrs '/' dvalues '/'
	|	datalists ',' daddrs '/' dvalues '/'
	|	datalists daddrs '/' dvalues '/'
	;

daddrs:		daddr
	|	daddrs ',' daddr
	;

daddr:		kID
	|	kID '(' explist ')'
	|	kID '(' explist ')' '(' sbound ':' sbound ')'
	|	kID '(' sbound ':' sbound ')'
	|	'(' daddrs ',' kID '=' exp ',' exp ')'
	|	'(' daddrs ',' kID '=' exp ',' exp ',' exp ')'
	;

explist:	exp
	|	explist ',' exp
	;

dvalues:	constant
	|	kICONST '*' constant
	|	kID '*' constant
	|	dvalues ',' constant
	|	dvalues ',' kICONST '*' constant
	|	dvalues ',' kID '*' constant
	;

namelistcomma:	'/' kID '/' kID ','
	|	namelistcomma '/' kID '/' kID ','
	|	namelistcomma kID ','
	|	namelist '/' kID '/' kID ','
	;

namelist:	'/' kID '/' kID
	|	namelist '/' kID '/' kID
	|	namelistcomma kID
	|	namelistcomma '/' kID '/' kID
	;

cblistcomma:	'/' kID '/' comiddim ','
	|	kCONCAT comiddim ','
	|	comiddim ','
	|	cblistcomma comiddim ','
	|	cblistcomma  '/' kID '/' comiddim ','
	|	cblistcomma  kCONCAT comiddim ','
	|	cblist '/' kID '/' comiddim ','
	|	cblist kCONCAT comiddim ','
	;

cblist:		'/' kID '/' comiddim
	|	kCONCAT comiddim
	|	comiddim
	|	cblistcomma comiddim
	|	cblistcomma  '/' kID '/' comiddim
	|	cblistcomma  kCONCAT comiddim
	|	cblist '/' kID '/' comiddim
	|	cblist kCONCAT comiddim
	;

comiddim:	kID
	|	kID arraydeclaror		{dodim($1,$2);}
	;

eitherstmt:	kFORMAT '(' fmtlist ')'
	|	kDATA datalists
	|	assignment
	|
	;

thenstmts:	label execstmt kNL		{endexec($1);}
	|	label eitherstmt kNL		{endexec($1);}
	|	thenstmts label execstmt kNL	{endexec($2);}
	|	thenstmts label eitherstmt kNL	{endexec($2);}
	|	thenstmts error kNL		{yyerrok;}
	|	label error kNL			{yyerrok;}
	;

execstmts:	label execstmt { firststmt();} kNL	{ endexec($1);}
	|	execstmts label execstmt kNL	{ endexec($2);}
	|	execstmts label eitherstmt kNL	{ endexec($2);}
	|	execstmts error kNL	{ yyerrok; }
	;

ifhead:		kIF '(' exp 		{ lexbase->keyok = 1;}
	;

then:	
	|	kTHEN
	;

thenpart:	label kENDIF			{endexec($1);}
	|	thenstmts label kENDIF		{endexec($2);}
	|	label kELSE kNL thenstmts label kENDIF	{endexec($5);}
	|	thenstmts label kELSE kNL thenstmts label kENDIF {endexec($6);}
	|	label kELSE kNL label kENDIF	{endexec($4);}
	|	thenstmts label kELSE kNL label kENDIF	{endexec($5);}
	|	label kELSE ifhead ')' then kNL thenpart
	|	thenstmts label kELSE ifhead ')' then kNL thenpart
	;

dohead:		kDO kICONST kID		{lexbase->hconok=1;$$=dohead($2,$3);
					reflabel($2,yydbinfo[2]);}
	|	kDO kICONST ',' kID	{lexbase->hconok=1;$$=dohead($2,$4);
					reflabel($2,yydbinfo[2]);}
	|	kDO kID			{lexbase->hconok=1;$$=dohead(0,$2);}
	;

execstmt: 	ifhead ')' then kNL {firststmt(); endexec(0);} thenpart
	|	kCONTINUE 
	|	kGOTO kICONST 		{reflabel($2,yydbinfo[2]);}
	|	kGOTO '(' lbllist ')' exp 
	|	kGOTO '(' lbllist ')' ',' exp 
	|	kGOTO kID 			{doacrossid($2,yydbinfo[2]);}
	|	kGOTO kID '(' lbllist ')' 	{doacrossid($2,yydbinfo[2]);}
	|	kGOTO kID ',' '(' lbllist ')'	{doacrossid($2,yydbinfo[2]);}
	|	kASSIGN kICONST kTO lvalue {reflabel($2,yydbinfo[2]);}
	|	ifhead ')' execstmt 		
	|	ifhead ')' assignment 		
	|	ifhead ')' kICONST ',' kICONST ',' kICONST  	
			{reflabel($3,yydbinfo[3]); reflabel($5,yydbinfo[5]); 
				reflabel($7,yydbinfo[7]);}
	|	doacross dokeylist kNL label dohead '=' exp ',' exp	
			{doacrosshead($4,$5,$7,$9,expint(1),yydbinfo[6],
				yydbinfo[8],0);}
	|	doacross dokeylist kNL label dohead '=' exp ',' exp ',' exp
			{doacrosshead($4,$5,$7,$9,$11,
				yydbinfo[6],yydbinfo[8],yydbinfo[10]);}
	|	kORDER kID		{doorder($2);}
	|	kENDORDER kID		{doendorder($2);}
	|	kLOCK kID		{dolock($2);}
	|	kUNLOCK kID		{dounlock($2);}
	|	dohead '=' exp ',' exp  	
	|	dohead '=' exp ',' exp ',' exp 	
	|	kDOWHILE '(' exp ')'	{do_while($1,$3);}
	|	kENDDO			{enddo();}
	|	kSTOP 
	|	kSTOP constant
	|	kPAUSE 
	|	kPAUSE constant 
	|	kCALL kID 		{subrcall($2,yydbinfo[2]);}
	|	kCALL kID arglist 	{subrcall($2,yydbinfo[2]);}
	|	kRETURN 
	|	kRETURN exp 
	|	kREAD '(' rdwrkeys ')' daddrs 
	|	kREAD '(' rdwrkeys ')'  
	|	kREAD npposkey ',' daddrs 
	|	kREAD npposkey  
	|	kWRITE '(' rdwrkeys ')' outlist 
	|	kWRITE '(' rdwrkeys ')'  
	|	kPRINT npposkey ',' outlist 
	|	kPRINT npposkey 
	|	kDECODE '(' exp ',' exp ',' kID ')' daddrs
	|	kDECODE '(' exp ',' exp ',' kID ',' namedkey ')' daddrs
	|	kENCODE '(' exp ',' exp ',' kID ')' outlist
	|	kENCODE '(' exp ',' exp ',' kID ',' namedkey ')' outlist
	|	kDECODE '(' exp ',' exp ',' kID ')' 
	|	kDECODE '(' exp ',' exp ',' kID ',' namedkey ')' 
	|	kENCODE '(' exp ',' exp ',' kID ')' 
	|	kENCODE '(' exp ',' exp ',' kID ',' namedkey ')' 
	|	kOPEN  iockeys 
	|	kCLOSE  iockeys 
	|	kINQUIRE  iockeys 
	|	kBACKSPACE iockeys 
	|	kREWIND iockeys 
	|	kENDFILE iockeys 
	|	kDEFINEFILE filelist
	|	kFIND '(' filerec ')'
	;

doacross:	kDOACROSS		{dotab = newdoacross();}
	;

dokeylist:				
	|	dokeys
	;
dokeys:		dokey			
	|	dokeys ',' dokey		
	;

dokey:		kCHUNK '=' exp	{if (dotab->dostmt == 0)dotab->chunk = $3;
			lexbase->keyok = 1;}
	|	kUNROLL '=' exp	{if (dotab->dostmt == 0)dotab->unroll = intcon($3);
			lexbase->keyok = 1;}
	|	kLASTLOCAL '(' idlist ')'
			{addclause(&dotab->lastlocals,$3); lexbase->keyok = 1;}
	|	kLOCAL '(' idlist ')'	
			{addclause(&dotab->locals,$3); lexbase->keyok = 1;}
	|	kSHARE '(' idlist ')'	
			{addclause(&dotab->share,$3); lexbase->keyok = 1;}
	|	kLOCKS '(' idlist ')'   
			{addclause(&dotab->locks,$3); lexbase->keyok = 1;}
	|	kORDER '(' idlist ')'   
			{addclause(&dotab->order,$3); lexbase->keyok = 1;}
	|	kREDUCTION '(' slicelist ')'
			{addreduceclause(&dotab->reduce,$3); lexbase->keyok = 1;}
	;

slicelist:	slice			{$$=slice_list_cons($1,0);}
	|	slicelist ',' slice	{$$=slice_list_cons($3,$1);}
	;
slice:		kID			{$$=slice_whole_id($1);}
	|	kID '(' triplelist ')'	{$$=slice_part_id($1,$3);}
	;
triplelist:	triple			{$$=start_triple($1);}
	|	triple ',' triplelist	{$$=append_triple($3,$1);}
	;
triple:		':'			{$$ = make_triple(0,0,0);}
	|	exp			{$$ = make_triple($1,0,0);}
	|	exp ':' exp		{$$ = make_triple($1,$3,0);}
	|	exp ':' exp ':' exp	{$$ = make_triple($1,$3,$5);}
	;

define:		kID '(' exp ',' exp ',' kID ',' kID ')'
	|	kICONST '(' exp ',' exp ',' kID ',' kID ')'
	;

filelist:	define
	|	filelist ',' define
	;

assignment:	lvalue '=' exp		{reductionop($1,$3);}
	;
fmtitem:	kID
	|	kICONST
	|	kHCONST
	|	kSCONST
	|	'(' fmtlist ')'
	;

fmtlist: 	
	|	fmtlist '.'
	|	fmtlist ','
	|	fmtlist '/'
	|	fmtlist ':'
	|	fmtlist '$'
	|	fmtlist '\\'
	|	fmtlist '+'
	|	fmtlist '-'
	|	fmtlist kCONCAT
	|	fmtlist fmtitem
	;

iockeys:	'(' iocklist ')'
	|	npposkey
	;

sbound:		exp
	|	
	;

npexp:		kID			{doacrossid($1,yydbinfo[1]);}
	|	kID arglist 			{expidfun($1,$2,yydbinfo[1]);}
	|	kID '(' sbound ':' sbound ')'	{doacrossid($1,yydbinfo[1]);}
	|	kID arglist '(' sbound ':' sbound ')' 
					{doacrossid($1,yydbinfo[1]);}
	|	kICONST
	|	kSCONST
	|	npexp '+' npexp
	|	npexp '-' npexp
	|	'-' npexp
	|	'+' npexp
	|	npexp kSTARSTAR npexp
	|	npexp '*' npexp
	|	npexp '/' npexp
	;

iocklist:	namedkey
	|	poskey
	|	iocklist ',' namedkey
	;

rdwrkeys:	unitkey		
	|	unitkey ',' namedkeys
	|	unitkey ',' poskey 	
	|	unitkey ',' poskey ',' namedkeys
	|	firstkey '=' exp 
	|	firstkey '=' '*'
	|	firstkey '=' exp ',' namedkeys
	|	firstkey '=' '*' ',' namedkeys
	|	filerec 
	|	filerec ',' poskey
	|	filerec ',' poskey ',' namedkeys
	|	filerec ',' namedkeys
	;

firstkey:	kID	{doacrossid($1,yydbinfo[1]);lexbase->hconok = 1;}
	;

unitkey:	poskey					{lexbase->hconok = 1;}
	;

filerec:	exp {lexbase->hconok = 0;} '\'' exp	{lexbase->hconok = 1;}
	;

namedkeys:	namedkey
	|	namedkeys ',' namedkey
	;

npposkey:	npexp
	|	'*'
	;

poskey:		exp
	|	'*'
	;

namedkey:	kID '=' exp
	|	kID '=' '*'
	;

outlist:	outlist ',' outlist
	|	'(' outlist '=' exp ',' exp ')'
	|	'(' outlist '=' exp ',' exp ',' exp ')'
	|	'(' outlist ')'
	|	kID				{doacrossid($1,yydbinfo[1]);}
	|	kID arglist 			{expidfun($1,$2,yydbinfo[1]);}
	|	kID arglist '(' sbound ':' sbound ')'
						{doacrossid($1,yydbinfo[1]);}
	|	kID '(' sbound ':' sbound ')'	{doacrossid($1,yydbinfo[1]);}
	|	kDCONST
	|	kRCONST
	|	kICONST
	|	kHCONST
	|	kSCONST
	|	kFALSE
	|	kTRUE
	|	outlist kAND outlist
	|	outlist kOR outlist
	|	outlist kEQV outlist
	|	outlist kNEQV outlist
	|	outlist '+' outlist
	|	outlist '-' outlist
	|	kNOT outlist 
	|	'-' outlist
	|	'+' outlist
	|	outlist kSTARSTAR outlist
	|	outlist '*' outlist
	|	outlist '/' outlist
	|	outlist kCONCAT outlist
	|	outlist kEQ outlist
	|	outlist kNE outlist
	|	outlist kGE outlist
	|	outlist kGT outlist
	|	outlist kLT outlist
	|	outlist kLE outlist
	;

lbllist:	kICONST			{reflabel($1,yydbinfo[1]);}
	|	lbllist ',' kICONST	{reflabel($3,yydbinfo[3]);}
	;

lvalue:		kID			{$$=$1;}
	|	kID '(' sbound ':' sbound ')'	
					{$$=$1;doacrossid($1,yydbinfo[1]);}
	|	kID arglist 		{$$=$1;chkstfun($1,yydbinfo[1],$2);}
	|	kID arglist '(' sbound ':' sbound ')'		
					{$$=$1;chkstfun($1,yydbinfo[1],$2);}
	;


constexplist:	constexp
	|	constexplist ',' constexp
	;

constexp:	exp
	;

arglist:	'(' arg ')'	
			{$$=argtemp($<table>0,0,yydbinfo[1],$2,yydbinfo[3]);}
	|	arglistplus arg ')' 
			{$$=argtemp($<table>0,$1,yydbinfo[1],$2,yydbinfo[3]);}
	|	'(' ')'	{$$=0;}
	;

arglistplus:	'(' arg ','	
			{$$=argtemp($<table>0,0,yydbinfo[1],$2,yydbinfo[3]);}
	|	arglistplus arg ',' 
			{$$=argtemp($<table>0,$1,yydbinfo[1],$2,yydbinfo[3]);}
	;

arg:		exp
	|	'*' kICONST	{$$=0;reflabel($2,yydbinfo[2]);}
	|	'&' kICONST	{$$=0;reflabel($2,yydbinfo[2]);}
	;

exp:		kID				{$$=expid($1,yydbinfo[1]);}
	|	kID arglist 			{$$=expidfun($1,$2,yydbinfo[1]);}
	|	kID arglist '(' sbound ':' sbound ')'	
						{$$=expid($1,yydbinfo[1]);}
	|	kID '(' sbound ':' sbound ')'	{$$=expid($1,yydbinfo[1]);}
	|	kDCONST		{$$ = unop(OPLOAD,INCONST,makedbl($1));}
	|	kRCONST		{$$ = unop(OPLOAD,INCONST,makereal($1));}
	|	kICONST		{$$ = expint($1);}
	|	kFALSE		{$$ = unop(OPLOAD,INCONST,makelog(0));}
	|	kTRUE		{$$ = unop(OPLOAD,INCONST,makelog(1));}
	|	kHCONST		{$$ = unop(OPLOAD,INCONST,makestring($1));}
	|	kSCONST		{$$ = unop(OPLOAD,INCONST,makestring($1));}
	|	'(' constant ',' constant ')'	
				{$$ = unop(OPLOAD,INCONST,makecmpx($2,$4));}
	|	exp kAND exp	{$$ = binop(OPAND,$1,$3);}
	|	exp kOR exp	{$$ = binop(OPOR,$1,$3);}
	|	exp kEQV exp	{$$ = binop(OPEQ,$1,$3);}
	|	exp kNEQV exp	{$$ = binop(OPNE,$1,$3);}
	|	exp '+' exp	{$$ = binop(OPADD,$1,$3);}
	|	exp '-' exp	{$$ = binop(OPSUB,$1,$3);}
	|	kNOT exp 	{$$ = unop(OPNOT,INRESULT,$2);}
	|	'-' exp		{$$ = unop(OPNEG,INRESULT,$2);}
	|	'+' exp		{$$ = $2;}
	|	exp kSTARSTAR exp	{$$ = binop(OPPWR,$1,$3);}
	|	exp '*' exp	{$$ = binop(OPMULT,$1,$3);}
	|	exp '/' exp	{$$ = binop(OPDIV,$1,$3);}
	|	exp kCONCAT exp	{$$ = binop(OPCAT,$1,$3);}
	|	exp kEQ exp	{$$ = binop(OPEQ,$1,$3);}
	|	exp kNE exp	{$$ = binop(OPNE,$1,$3);}
	|	exp kGE exp	{$$ = binop(OPGE,$1,$3);}
	|	exp kGT exp	{$$ = binop(OPGT,$1,$3);}
	|	exp kLT exp	{$$ = binop(OPLT,$1,$3);}
	|	exp kLE exp	{$$ = binop(OPLE,$1,$3);}
	|	'(' exp ')'	{$$ = $2;}
	;

constant:	kID
	|	'+' kDCONST	{$$ = makedbl($2);}
	|	'+' kRCONST	{$$ = makereal($2);}
	|	'+' kICONST	{$$ = makeint($2);}
	|	'-' kDCONST	{*((double *)$2) = -*((double *)$2);
					$$ = makedbl($2);}
	|	'-' kRCONST	{*((double *)$2) = -*((double *)$2);
					$$ = makereal($2);}
	|	'-' kICONST	{$$ = makeint(-$2);}
	|	kDCONST		{$$ = makedbl($1);}
	|	kRCONST		{$$ = makereal($1);}
	|	kICONST		{$$ = makeint($1);}
	|	kFALSE		{$$ = makelog(0);}
	|	kTRUE		{$$ = makelog(1);}
	|	kHCONST		{$$ = makestring($1);}
	|	kSCONST		{$$ = makestring($1);}
	|	'(' constant ',' constant ')'	{$$ = makecmpx($2,$4);}
	|	'-' '(' constant ',' constant ')'	
				{*((double *)$3) = -*((double *)$3);
					*((double *)$5) = -*((double *)$5);
					$$ = makecmpx($3,$5);}
	;
	
