/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987 Sequent Computer Systems, Inc.
 * All rights reserved
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 *
 */

/* block operators/operands */
union inptr {
	struct tentry *table;		/* cases INADDR, INCONST */
	struct output *result;		/* case INRESULT */
};
struct operation {
	int type:8;		/* type of operator */
#define OPTYOP 1
#define OPTYINS 2
	struct input *inputs;
	struct output *outputs;
	struct constraint *pred, *succ;
	union {
		/* before code generation */
		int op;
		/* after code generation */
		struct instruction *in;
		/* block entry/exit */
		struct block *b;
	} x;
	struct text *optext;	/* debugging text list */
};
struct input {
	struct input *next;		/* next input to operation */
	struct input *nextconsumer;	/* next consumer */
	int innumb:16;			/* input number */
	int intype:8;			/* input type */
#define INRESULT 1
#define INCONST 2
#define INADDR 3
	union inptr x;
};
struct output {
	struct output *next;		/* next output from operation */
	struct input *consumers;	/* consuming operation */
	struct operation *producer;	/* producing operation */
	struct tentry *t;		/* type of result */
	int reg;			/* symbolic register number */
	int outnumb:16;			/* output number */
	int regclass:16;		/* register class */
#define RGCLINT 1
#define RCCLFLOAT 2
	int low, high;			/* bounds of result */
};
struct constraint {
	struct constraint *pnext, *snext;
	struct sbase *detail;
	struct operation *predop, *succop;
	int reason: 8;
};

#define OPLOAD 1*TYINC
#define OPSTORE 2*TYINC
#define OPADD 3*TYINC
#define OPMULT 4*TYINC
#define OPDIV 5*TYINC
#define OPSUB 6*TYINC
#define OPNEG 7*TYINC
#define OPCOPY 8*TYINC
#define OPNOT 9*TYINC
#define OPAND 10*TYINC
#define OPOR 11*TYINC
#define OPXOR 12*TYINC
#define OPPWR 13*TYINC
#define OPCAT 14*TYINC
#define OPEQ 15*TYINC
#define OPNE 16*TYINC
#define OPGE 17*TYINC
#define OPGT 18*TYINC
#define OPLE 19*TYINC
#define OPLT 20*TYINC
#define OPCALL 21*TYINC
#define OPCOMPOSE 22*TYINC
#define OPMIN 23*TYINC
#define OPMAX 24*TYINC
#define OPSIN 25*TYINC
#define OPCOS 26*TYINC
#define OPTAN 27*TYINC
#define OPATAN 28*TYINC
#define OPATAN2 29*TYINC
#define OPSQRT 30*TYINC
#define OPEXP 31*TYINC
#define OPLOG 32*TYINC
#define OPTANH 33*TYINC
#define OPSINH 34*TYINC
#define OPCOSH 35*TYINC
#define OPABS 36*TYINC
#define OPACOS 37*TYINC
#define OPASIN 38*TYINC
#define OPRECV 39*TYINC
#define OPSPINNZ 40*TYINC
#define OPSTKALLOC 41*TYINC
#define OPSTKRELEASE 42*TYINC
#define OPLDADDR 43*TYINC
#define OPWRFMTLIST 44*TYINC
#define OPSTARTWRFMT 45*TYINC
#define OPENDWRFMT 46*TYINC
#define OPSIZEOF 47*TYINC
#define OPMAXX 48*TYINC
#define OPMAXXL 49*TYINC
#define OPMINX 50*TYINC
#define OPMINXL 51*TYINC
#define OPCNV 64*TYINC
#define OPCNVREAL OPCNV+TYREAL*TYINC
#define OPCNVDOUBLE OPCNV+TYDOUBLE*TYINC
#define OPCNVINT OPCNV+TYINT*TYINC
#define OPCNVCOMPLEX OPCNV+TYCOMPLEX*TYINC
