/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987 Sequent Computer Systems, Inc.
 * All rights reserved
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 *
 */

#define YYLMAX 1920
#define MAXLINE 132
struct lexcontext {
	int yyleng; 
	int yymorfg;
	int yytchar;
	struct yysvf *yyestate;
	char yytext[YYLMAX];
	struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
	char yysbuf[YYLMAX];
	char *yysptr; /* = yysbuf */
	int *yyfnd;
	int yyprevious; /* = YYNEWLINE */
	/* lexical state switches for Fortran */
	int hconok;	/* hollerith constants are allowed here */
	int keyok;	/* keywords are allowed here */
	int assignscan;	/* disambiguating keywords by assignment scan */
	int funok;	/* is the function keyword ok here */
	int sttype;	/* type of statement if not zero */
	int sourcelang;	/* source language (vms, f77, etc) */
	/* input position state */
	struct stseg *stsegptr;
	char *inptr, *endptr;
	/* input position at beginning of token */
	struct stseg *tokenseg;
	char *tokenchar;
	int unputsize;
	char unputbuffer[MAXLINE];
};
struct stseg {
	struct filetab *f;	/* source file table entry */
	int lineno;		/* source line number */
	int offset;		/* beginning of line character 
					position in file */
	int newstmt;		/* true if new statement */
	int stlen;		/* length of statement segment */
	char text[MAXLINE];	/* actual detabbed text */
	char stoffset[MAXLINE];	/* offset into statement */
	struct stseg *prev, *next;	/* previous, next statement or segment*/
};
struct filetab {
	struct filetab *prev;	/* file that #included this file */
	FILE *file;
	int offset;
	int lineno;
	char filename[MAXLINE];
};
#define VMSLANG 1
#define F77LANG 2
#define IBMLANG 3
