/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987 Sequent Computer Systems, Inc.
 * All rights reserved
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 *
 */

/* fortran 77 parser test */
#include <stdio.h>
#include "lex.h"
#include "pool.h"
#include "symbol.h"
#define YYNEWLINE 10
extern struct lexcontext *lexbase, parsercontext, keychkcontext;
#ifdef YYDEBUG
extern yydebug;
#endif
struct pool tempic, stmts, pupass1, progtables;
struct symindex *externals, *thisunit;
struct tentry *unitname = 0;
extern struct filetab *currentfile, outputfiletab;
FILE *outfile;
int col1d = 0;
int col72 = 0;
int reversed_args = 0;		/* set if -e option encountered after v3.0 */
int error_count = 0;		/* count of yyerror calls */
int systemids = 1;
int reentrant = 1;		/* shared stack implementation */
int needtripvar = 0;		/* doacross trip counter variable needed */
struct stseg *specinsert = 0;	/* where to insert spec statement */
extern struct stseg *firstdosub;		/* doacross subroutines */
	


main(argc, argv)
int argc;
char *argv[];
{
	int i;
	char *cp, *infilename;
	extern struct symindex *newtable();
	extern int strcmp();
	struct stseg *lastst;
#ifdef YYDEBUG
	yydebug = 1;
#endif
	initpool1(&progtables);
	initpool1(&stmts);
	initpool1(&tempic);
	initpool1(&pupass1);
	externals = newtable(&progtables);
	thisunit = newtable(&pupass1);
	thisunit->parent = externals;
	initimplicit();
	lexbase = &parsercontext;
	lexbase->yysptr = lexbase->yysbuf;
	lexbase->yyprevious = YYNEWLINE;
	lexbase->hconok = 1;
	lexbase->keyok = 1;
	lexbase->funok = 1;
	lexbase->sttype = 0;
	lexbase->assignscan = 0;
	lexbase->unputsize = 0;
	/* process options and arguments */
	++argv;
	infilename = 0;
	for (i = 1; i < argc; i++, argv++) {
		cp = *argv;
		if (*cp++ == '-'){
			if (strcmp(*argv,"-o")==0) {argv++; i++; continue;}
			if (strcmp(*argv,"-c72") ==0) {col72 = 1; continue;}
			if (strcmp(*argv,"-dc") ==0) {col1d = 1; continue;}
			if (strcmp(*argv,"-e") ==0) {reversed_args = 1; continue;}
			if (strcmp(*argv,"-ibm") ==0) 
				{parsercontext.sourcelang = IBMLANG; continue;}
			if (strcmp(*argv,"-vms") ==0) 
				{parsercontext.sourcelang = VMSLANG; continue;}
			if (strcmp(*argv,"-f77") ==0) 
				{parsercontext.sourcelang = F77LANG; continue;}
		} else if (*(--cp) == '+'){
			if (strcmp(*argv,"+o")==0) {argv++; i++; continue;}
			if (strcmp(*argv,"+c72") ==0) {col72 = 1; continue;}
			if (strcmp(*argv,"+dc") ==0) {col1d = 1; continue;}
			if (strcmp(*argv,"+e") ==0) {reversed_args = 1; continue;}
			if (strcmp(*argv,"+ibm") ==0) 
				{parsercontext.sourcelang = IBMLANG; continue;}
			if (strcmp(*argv,"+vms") ==0) 
				{parsercontext.sourcelang = VMSLANG; continue;}
			if (strcmp(*argv,"+f77") ==0) 
				{parsercontext.sourcelang = F77LANG; continue;}
		} else {infilename = *argv;}
	}
	if (infilename) {
		currentfile = NEW(&progtables,filetab);
		for (cp = currentfile->filename; *cp++ = *infilename++;);
		if ((currentfile->file = fopen(currentfile->filename,"r")) 
			== NULL) {
			fprintf(stderr,"cannot open input file %s\n",
				currentfile->filename);
			exit(2);
		}
		currentfile->lineno = 1;
		currentfile->offset = 0;
		currentfile->prev = 0;
		for (cp = outputfiletab.filename, infilename = currentfile->filename;
			*cp++ = *infilename++;) {
			if (infilename[-1] == '/') cp = outputfiletab.filename; 
			if (infilename[0] == 0 ||
				(infilename[0] == 'f' && 
					infilename[1] == 0) ||
				(infilename[0] == 'c' && 
					infilename[1] == 'm' && 
					infilename[2] == 'p' && 
					infilename[3] == 0) ||
				(infilename[0] == 'f' && 
					infilename[1] == 'o' && 
					infilename[2] == 'r' && 
					infilename[3] == 0)) break;
		}
		*cp++ = 'f';
		*cp++ = 'p';
		*cp++ = 'p';
		*cp = 0;
		if ((outfile = fopen(outputfiletab.filename,"w")) == NULL) {
			fprintf(stderr,"cannot open %s for writing\n", 
				outputfiletab.filename);
			exit(3);
		}
		outputfiletab.file = outfile;
		outputfiletab.prev = 0;
		outputfiletab.lineno = 1;
		outputfiletab.offset = 0;
	} else {
		fprintf(stderr,"no input file name\n");
		exit(1);
	}
	fprintf(outfile,"$system\n");
	initstrd();
	if (yyparse()) error_count += 1;
	lastst = lexbase->stsegptr;
	while (lastst->prev) lastst = lastst->prev;
	while (lastst->next) {
		ppout(lastst);
		lastst = lastst->next;
	}
	for (lastst = firstdosub; lastst; lastst = lastst->next)
		ppout(lastst);
	fclose(outfile);
#ifdef PRINTMEM
	printpool("progtables",&progtables);
	printpool("tempic",&tempic);
	printpool("stmts",&stmts);
	printpool("pupass1",&pupass1);
#endif
	return(error_count);
}

printpool(pn, p)
char *pn;
struct pool *p;
{
	int i;
	struct pagetable **pt;
	for (i= 0, pt = p->pt->x.pt; 
		*pt++; i += PAGESIZE); 
	fprintf(stderr,"pool %s used %d bytes\n", pn, i);
}

yywrap()
{
	return(1);
}

yywarn(s)
char *s;
{
	int i;
	struct stseg *sp;
	sp = lexbase->stsegptr;
	i = lexbase->inptr - sp->text;
	if (i == 0 && sp->prev) {
		sp = sp->prev;
		i = sp->stlen;
	}
	sp->text[sp->stlen] = 0;
	printf("\"%s\", line %d: %s \n",
		sp->f->filename, sp->lineno, s);
	if (!sp->newstmt) {
		printf("     &");
		i += 6;
	}
	printf("%s\n", sp->text);
	while(i--) printf(" ");
	printf("^\n");
}
yyerror(s)
char *s;
{
	error_count += 1;
	yywarn(s);
}
