/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986 Sequent Computer Systems, Inc.
 * All rights reserved
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 *
 */

/* allocate small (less than a page) structures out of pool */
/* #define RESETCLEAR */
#define ROUNDUP
#include <stdio.h>
#include "pool.h"
#define MCW 4

/* allocate a page at a page boundary */
char *palloc()
{
	extern char *malloc();
	char *p;
	int i;
#ifdef ALIGN
	i = ((int)malloc(0)) & PAGEOFFMASK;
	if (i) {
		p = malloc(PAGESIZE - i - MCW);
		printf("%d bytes of memory wasted at 0x%x\n",
			PAGESIZE - i - MCW,p);
	}
#endif
	p = malloc(PAGESIZE);
#ifdef debug
	printf("palloc returns a page a 0x%x\n", p);
#endif
#ifdef ALIGN
	if (((int)p) & PAGEOFFMASK) {
		fprintf(stderr, "palloc failure 0x%x i was 0x%x\n",p,i);
		exit(1);
	}
#endif
	return(p);
}

char *allocpool1(p, nc)
register struct pool *p;
int nc;
{
	register char *j;
#ifdef ROUNDUP
	nc = (nc + 3) & (-4);
#endif
#ifdef debug
	printf("enter allocpool1(0x%x, %d)\n", p, nc);
#endif
#ifdef ALIGN
	if ((((int)p->top) & PAGEOFFMASK) + nc > PAGESIZE &&
#else
	if (p->top + nc > p->pt->x.page[p->npages-1] + PAGESIZE && 
#endif
		(p->top = p->pt->x.page[p->npages++]) == 0)
		p->pt->x.page[p->npages-1] = p->top = palloc();
	j = p->top;
	p->top += nc;
#ifdef debug
	printf("allocpool1 returns 0x%x. top = %x used %d npages %d\n", 
		j, p->top, p->top - p->pt->x.page[p->npages-1], p->npages);
#endif
	return(j);
}
/* reset a memory pool */
resetpool1(p)
register struct pool *p;
{
	int i, np;
#ifdef debug
	printf("reseting pool %x\n",p);
#endif
	p->top = p->pt->x.page[0];
	p->npages = 0;
#ifdef RESETCLEAR
	for (np = 0; p->pt->x.pt[np]; np++)
		for (i = 0; i < PAGESIZE/4; i++)
			p->pt->x.pt[np]->x.pt[i] = 0;
#endif
}
initpool1(p)
register struct pool *p;
{
	register int i;
	struct pagetable **pp;
	p->alloc = allocpool1;
	p->reset = resetpool1;
	p->pt = (struct pagetable *) palloc();
	pp = p->pt->x.pt;
	for (i = 0; i < PAGESIZE/4; i++) *pp++ = 0;
	p->top = p->pt->x.page[0] = palloc();
	p->npages = 1;
#ifdef debug
	printf("end initialization of pool at 0x%x\n", p);
	printf("p->top %x, p->pt %x\n", p->top, p->pt);
#endif
}

