/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987 Sequent Computer Systems, Inc.
 * All rights reserved
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 *
 */

/* some specification statement semantic actions */
#define isconst(z) (z->producer->x.op == OPLOAD && z->producer->inputs->intype == INCONST)
#include <stdio.h>
#include "symbol.h"
#include "pool.h"
#include "ic.h"
#include "action.h"
#include "lex.h"
extern struct pool progtables, tempic, pupass1, stmts;
struct tentry *oldsym(), *newsym();
extern struct symindex *externals, *thisunit, *newtable();
extern struct stseg *specinsert, *newsegappend(), *chkseglen();
extern int reentrant;
extern struct lexcontext *lexbase;
extern struct idlist *statictemplist;
extern int didexecutable;
extern struct doacross *dotab;
extern struct dotbl *dostack;
extern struct tentry *lettertype[28];
int impnonesw = 0;		/* implicit none in effect */
struct stseg *execinsert = 0;	/* where to insert first executable statement */

/* implicitly type an identifier--issue warning if implicit none  */
struct tentry *imptype(id)
struct tentry *id;
{
	char buf[80];
	if (impnonesw) {
		sprintf(buf,"implicitly typing %s as %s", id->symbol,
		lettertype[lettercode(id->symbol[0])]->symbol);
		yywarn(buf);
	}
	return(lettertype[lettercode(id->symbol[0])]);
}
/* set implicit none on */
impnone()
{
	impnonesw = 1;
}
/* construct an array type */
struct tentry *newarraytype(basetype, indextype)
struct tentry *basetype, *indextype;
/* basetype may be nil */
/* Fortran uses structural equivalence--store types in table */
{
	char *t, *s, *newsymbol;
	struct tentry *newt;
	int newlen;
	newlen = strlenp1(indextype->symbol)+3;
	if (basetype) newlen += strlenp1(basetype->symbol);
	else	newlen++;
	newsymbol = t = (*(pupass1.alloc))(&pupass1,newlen);
	if (basetype) for (s = basetype->symbol; *t++ = *s++;);
	else 	{*t++ = '?'; t++;}
	t[-1] = '[';
	for (s = indextype->symbol; *t++ = *s++;);
	t[-1] = ']';
	*t = 0;
	newt = oldsym(thisunit,newsymbol);
	while (newt && (newt->class != CLTYPE || 
		newt->x.type.elemtype != TYARRAY ||
		newt->x.type.subtype.array.base != basetype ||
		newt->x.type.subtype.array.index != indextype ||
		strcmp(newsymbol,newt->symbol) != 0))
			newt = newt->next;
	if (!newt) {
		newt = newsym(&pupass1,thisunit,newsymbol,0);
		newt->class = CLTYPE;
		newt->x.type.elemtype = TYARRAY;
		newt->x.type.size = basetype ? basetype->x.type.size *
			indextype->x.type.size : 0;
		newt->x.type.subtype.array.base = basetype;
		newt->x.type.subtype.array.index = indextype;
	}
#ifdef debugnewarraytype
	dumptentry(newt);
#endif
	return(newt);
}
/* construct a pointer type */
struct tentry *newptrtype(ty)
struct tentry *ty;
{
	char *t, *s, *newsymbol;
	struct tentry *newt;
	int newlen;
	newlen = 4;
	if (ty) newlen += strlenp1(ty->symbol);
	else newlen++;
	newsymbol = t = (*(pupass1.alloc))(&pupass1,newlen);
	*t++ = '*';
	*t++ = '(';
	if (ty) for (s = ty->symbol; *t++ = *s++;);
	else 	{ *t++ = '?';t++;}
	t[-1] = ')';
	*t = 0;
	newt = oldsym(thisunit,newsymbol);
	while (newt && (newt->class != CLTYPE || 
		newt->x.type.elemtype != TYPTR ||
		newt->x.type.subtype.ptr.to != ty ||
		strcmp(newsymbol,newt->symbol) != 0))
			newt = newt->next;
	if (!newt) {
		newt = newsym(&pupass1,thisunit,newsymbol,0);
		newt->class = CLTYPE;
		newt->x.type.elemtype = TYPTR;
		newt->x.type.size = 32;
		newt->x.type.subtype.ptr.to = ty;
	}
#ifdef debugnewptrtype
	dumptentry(newt);
#endif
	return(newt);
}
/* construct a new function type */
struct tentry *newfuntype(arg, res)
struct tentry *arg, *res;
{
	char *t, *s, *newsymbol;
	struct tentry *newt;
	int newlen;
	newlen = 3;
	if (res) newlen += strlenp1(res->symbol);
	else 	newlen++;
	if (arg) newlen += strlenp1(arg->symbol);
	else 	newlen++;
	newsymbol = t = (*(pupass1.alloc))(&pupass1,newlen);
	if (arg) for (s = arg->symbol; *t++ = *s++;);
	else	{*t++ = '?'; t++;}
	t[-1] = '-';
	*t++ = '>';
	if (res) for (s = res->symbol; *t++ = *s++;);
	else	{*t++ = '?'; *t++ = 0;}
	newt = oldsym(thisunit,newsymbol);
	while (newt && (newt->class != CLTYPE || 
		newt->x.type.elemtype != TYFUNC ||
		newt->x.type.subtype.func.argtype != arg ||
		newt->x.type.subtype.func.resulttype != res ||
		strcmp(newsymbol,newt->symbol) != 0))
			newt = newt->next;
	if (!newt) {
		newt = newsym(&pupass1,thisunit,newsymbol,0);
		newt->class = CLTYPE;
		newt->x.type.elemtype = TYFUNC;
		newt->x.type.size = 0;
		newt->x.type.subtype.func.argtype = arg;
		newt->x.type.subtype.func.resulttype = res;
	}
#ifdef debugnewfuntype
	dumptentry(newt);
#endif
	return(newt);
}
/* construct a new constant subrange type */
struct tentry *newrangetype(low, high)
int low, high;
{
	char buf[80];
	struct tentry *newt;
	sprintf(buf,"%d:%d\0",low,high);
	newt = oldsym(thisunit,buf);
	while (newt && (newt->class != CLTYPE || 
		newt->x.type.elemtype != TYRANGE ||
		newt->x.type.subtype.subrange.low != low ||
		newt->x.type.subtype.subrange.high != high ||
		strcmp(newsym,newt->symbol) != 0))
			newt = newt->next;
	if (!newt) {
		newt = newsym(&pupass1,thisunit,buf,0);
		newt->class = CLTYPE;
		newt->x.type.elemtype = TYRANGE;
		newt->x.type.size = 32;
		newt->x.type.subtype.subrange.base = inttype;
		newt->x.type.subtype.subrange.low = low;
		newt->x.type.subtype.subrange.high = high;
	}
#ifdef debugnewrangetype
	dumptentry(newt);
#endif
	return(newt);
}
/* construct a new parameterized subrange type */
struct tentry *newparmrangetype(low, high)
struct output *low, *high;
{
	char *t, buf[YYLMAX];
	struct tentry *newt, *temp;
	t = buf;
	if (low)	t = exprsym(low,buf);
	else 		{*t++ = '*';}
	*t++ = ':';
	if (high)	t = exprsym(high,t);
	else 		{*t++ = '*';}
	*t++ = 0;
	newt = oldsym(thisunit,newsym);
	while (newt && (newt->class != CLTYPE || 
		newt->x.type.elemtype != TYPRANGE ||
		strcmp(buf,newt->symbol) != 0))
			newt = newt->next;
	if (!newt) {
		newt = newsym(&pupass1,thisunit,buf,0);
		newt->class = CLTYPE;
		newt->x.type.elemtype = TYPRANGE;
		newt->x.type.size = 32;
		temp = genvar(newt->x.type.subtype.subrange.base = 
			inttype);
		newt->x.type.subtype.parmrange.lowexp = low;
		newt->x.type.subtype.parmrange.highexp = high;
		newt->x.type.subtype.parmrange.lowtemp = temp;
		temp = genvar(temp->t);
		newt->x.type.subtype.parmrange.hightemp = temp;
	}
#ifdef debugnewparmrangetype
	dumptentry(newt);
#endif
	return(newt);
}
/* return base type of identifier */
struct tentry *basetype(id)
struct tentry *id;
{
	struct tentry *dimtype;
	dimtype = id->t;
	while (dimtype) {
		switch (dimtype->x.type.elemtype) {
		case TYARRAY:
			dimtype = dimtype->x.type.subtype.array.base;
			break;
		case TYPTR:
			dimtype = dimtype->x.type.subtype.ptr.to;
			break;
		case TYFUNC:
			dimtype = dimtype->x.type.subtype.func.resulttype;
			break;
		default:	return(dimtype);
		}
	}
	return(0);
}
struct tentry *addbasetype(ty,base)
struct tentry *ty, *base;
{
	if (ty == 0) return(base);
	switch (ty->x.type.elemtype) {
	case TYARRAY:
		return(newarraytype(
			addbasetype(ty->x.type.subtype.array.base,base),
			ty->x.type.subtype.array.index));
		break;
	case TYPTR:
		return(newptrtype(addbasetype(ty->x.type.subtype.ptr.to,base)));
		break;
	case TYFUNC:
		return(newfuntype(ty->x.type.subtype.func.argtype,
			addbasetype(ty->x.type.subtype.func.resulttype,base)));
			
		break;
	/* not really right--substitute new base type */
	default:
		return(base);
		break;
	}
}
/* type and dimension actions */
/* type identifier id to be type t 
	This routine explores the wonders for FORTRAN typing, where
	components of the type (ala C or Pascal) are collected from
	subroutine/function statements, common/dimension statements, and
	"type" statements. */
dotype(id,t)
struct tentry *id, *t;
{
	char buf[80];
	struct tentry *bt;
	/* is there a base type already */
	if (bt = basetype(id)) {
		sprintf(buf,"already typed %s is already typed",id->symbol);
		if (bt == t) yywarn(buf);
		else	yyerror(buf);
		return;
	}
	id->t = addbasetype(id->t,t);
#ifdef debugdotype
	printf("the type of %s is now %s\n", id->symbol, id->t->symbol);
#endif
}
/* add dimension information */
struct tentry *adddim(bt, dim)
struct tentry *bt, *dim;
{
	char buf[80];
	if (!bt) return(dim);
	switch (bt->x.type.elemtype) {
	case TYPTR:
		return(newptrtype(adddim(bt->x.type.subtype.ptr.to,dim)));
	case TYFUNC:
			/* for 8x extensions */
		return(newfuntype(bt->x.type.subtype.func.argtype,
			adddim(bt->x.type.subtype.func.resulttype,dim)));
	case TYARRAY:
		sprintf(buf,"already dimensioned %s",bt->symbol);
		yyerror(buf);
		return(bt);
	default:	
		return(addbasetype(dim,bt));
	}
}
dodim(id,t)
struct tentry *id, *t;
{
	char buf[MAXLINE];
	struct tentry *bt;
	id->t = adddim(id->t, t);
	if (id->class == 0) id->class = CLVAR;
	if (id->class != CLVAR) {
		sprintf(buf, "symbol %s should be a variable", id->symbol);
		yyerror(buf);
	}
#ifdef debugdodim
	printf("the type of %s is now %s\n", id->symbol, id->t->symbol);
#endif
}
/* return a temporary type t for array of ? */
struct tentry *bound(lower, upper)
struct output *lower, *upper;
/* upper may be nil */
{
	if (!upper) {
		/* unknown last dimension */
		return(newparmrangetype(lower,upper));
	} else if (isconst(lower) && isconst(upper)) {
		/* nice, known at compile time dimensions */
		return(newrangetype(
			lower->producer->inputs->x.table->x.const.intval,
			upper->producer->inputs->x.table->x.const.intval));
	} else {
		/* parameterized (known at run time) dimensions */
		return(newparmrangetype(lower,upper));
	}
}
firststmt()
{
	if (!specinsert) {
		specinsert = lexbase->stsegptr;
		while (specinsert->prev) {
			specinsert = specinsert->prev; 
 			if (specinsert->newstmt) break;
		}
#ifdef debugfirststmt
		printf("first statement: %s\n", specinsert->text);
#endif
}	}
doend()
{
	int i;
	struct idlist *l;
	struct tentry *id;
	struct stseg *seg;
	char *t, *s;
	extern int needsdynalloc;

	if (dostack) yyerror("do statement label(s) not found");
	dostack = 0;
	dotab = 0;
	if (!reentrant && specinsert) {
#ifdef debugfirststmt
		printf("first statement: %s\n", specinsert->text);
#endif
		seg = NEW(&stmts,stseg);
		seg->newstmt = 1;
		seg->f = 0;
		seg->lineno = 0;
		seg->prev = specinsert->prev;
		if (seg->prev) seg->prev->next = seg;
		specinsert->prev = seg;
		seg->next = specinsert;
		t = seg->text;
		sprintf(t,"       save");
		while (*t++);
		t--;
		seg->stlen = t - seg->text;
	}
	if (specinsert && needsdynalloc) {
		seg = NEW(&stmts,stseg);
		seg->newstmt = 1;
		seg->f = 0;
		seg->lineno = 0;
		seg->prev = specinsert->prev;
		if (seg->prev) seg->prev->next = seg;
		specinsert->prev = seg;
		seg->next = specinsert;
		t = seg->text;
		sprintf(t,"       external m_dynalloc");
		while (*t++);
		t--;
		seg->stlen = t - seg->text;
	}
	if (specinsert && statictemplist) {
		/* declare static temporaries */
		for (i = 1; i < TYINC; i++) {
			/* search for a variable of this type */
			for (l = statictemplist; l; l = l->next )
				if ((id = basetype(l->id)) &&
					id->x.type.elemtype == i)
					break;
			if (l) {
#ifdef debugdoend
				printf("begin new type...\n");
				dumptentry(id);
				dumptentry(l->id);
#endif
				/* start new type statement */
				specinsert->prev = seg = 
					newsegappend(specinsert->prev);
				seg->next = specinsert;
				t = seg->text;
				for (s = "      "; *t++ = *s++;);
				t[-1] = ' ';
				for (s = id->symbol; *t++ = *s++;);
				t[-1] = ' ';
				for (; l; l = l->next )
					if (basetype(l->id) == id){
					s = l->id->symbol;
					specinsert->prev = seg = 
						chkseglen(seg,s,t);
					seg->next = specinsert;
					t = seg->text + seg->stlen;
					while (*t++ = *s++);
					t[-1] = ',';
				}
				*(--t) = 0;
				seg->stlen = t - seg->text;
#ifdef debugdoend
				printf("doend: %s\n",seg->text);
#endif
			}
		}
	}
	impnonesw = 0;	/* reset implicit none */
	didexecutable = 0;
	execinsert = specinsert = 0;
	needsdynalloc = 0;
	reentrant = 1;
	statictemplist = 0;
	recyclestbuf();
	(*(pupass1.reset))(&pupass1);
	thisunit = newtable(&pupass1);
	thisunit->parent = externals;
	initimplicit();
}
/* formal parameter */
struct tentry *startformal(id)
struct tentry *id;
{
	if (id) {
		if (id->t) {
			if (id->t->x.type.elemtype != TYPTR) {
				id->t = newptrtype(id->t);
			}
		} else {
			id->t = ptrundeftype;
	}	}
	return(0);
}
/* more formal parameters */
struct tentry *addformal(rec,id)
struct tentry *rec, *id;
{
	return(startformal(id));
}
