/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986 Sequent Computer Systems, Inc.
 * All rights reserved
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 *
 */

/* symbol table processing */
#include "symbol.h"
#include "pool.h"

#define hashfun(x) (x % NHASH)

int hashsum(s, ls)
char *s;
int *ls;
{
	int sum, i;
#ifdef debug
	char *os;
	os = s;
#endif
	for (sum=0,i=0; *s; i++) sum += i ^ (*s * *s++);
	*ls = i;
#ifdef debug
	printf("hashsum(%s) is %d, length is %d\n", os, sum, *ls);
#endif
	return(sum);
}
/* routine to search a hierarcy of symbol tables */
struct tentry *oldsym(t,s)
struct symindex *t;
char *s;
{
	int ih, isum, ls;
	struct tentry *e;

	isum = hashsum(s,&ls);
	ih = hashfun(isum);
	while (t) {
		e = t->hashtable[ih];
		while (e) {
#ifdef debug
			printf("oldsym checks symbol with sum %d ...\n",
				e->sum);
			dumptentry(e);
#endif
			if (isum == e->sum && strcmp(e->symbol,s) == 0)  {
#ifdef debug
				printf("oldsym finds %s\n", e->symbol);
#endif
				return(e);
			}
			e = e->next;
		}
		t = t->parent;
	}
	return(0);
}

struct tentry *newsym(mempool,t,s,parent)
struct pool *mempool;
struct symindex *t;		/* table */
char *s;			/* string */
struct tentry *parent;
{
	int ih, isum, ls;
	struct tentry *e, *enew;
	char *n;
#ifdef debug
	char *os;
	os = s;
#endif

	isum = hashsum(s, &ls);
	ih = hashfun(isum);
	enew = NEW(mempool,tentry);
	enew->symbol = n = (*(mempool->alloc))(mempool,ls+1);
	while (*n++ = *s++);
	enew->sum = isum;
	enew->parent = parent;
	enew->class = 0;
	enew->t = 0;
	enew->lexlevel = 0;
	enew->next = t->hashtable[ih];
	t->hashtable[ih] = enew;
#ifdef debug
	if (oldsym(t,os) != enew) 
		printf("oldsym can't find new symbol %s!\n", os);
#endif
	return(enew);
}

struct symindex *newtable(mempool)
struct pool *mempool;
{
	int i;
	struct symindex *t;
	t = NEW(mempool, symindex);
	for (i = 0; i < NHASH; i++) t->hashtable[i] = 0;
	return(t);
}
