/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987 Sequent Computer Systems, Inc.
 * All rights reserved
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 *
 */

#define NHASH 139
#define UNDEFINED 0

/* storage classes */
#define SCSTATIC 1
#define SCBASED 2
#define SCCOMMON 3
#define SCREG 4

/* symbol class tags */
#define CLVAR 1
#define CLSBASE 2
#define CLTYPE 3
#define CLUNIT 4
#define CLCONST 5
#define CLFILE 6

/* doacross type tags */
#define DOLOCAL 1
#define DOLASTLOCAL 2
#define DOSHARE 3
#define DOREDUCTION 4
#define DOORDER 5
#define DOLOCK 6

/* type tags */
#define TYVOID 1
#define TYARRAY 2
#define TYRANGE 3
#define TYPTR 4
#define TYREC 5
#define TYFIELD 6
#define TYLOG 7
#define TYINT 8
#define TYREAL 9
#define TYDOUBLE 10
#define TYCOMPLEX 11
#define TYCHAR 12
#define TYUSINT 13
#define TYUSCHAR 14
#define TYFUNC 15
#define TYPRANGE 16
#define TYLABEL 17
#define TYSHORT 18
#define TYUSHORT 19
#define TYINC 32
#define TYSIZE 5

#define EXTFUNC 1
#define INTRINSICFUNC 2
#define STFUNC 3
struct where {
	int lineno;
	int offset;
	struct filetable *f;
};
struct symindex {
	struct tentry *hashtable[NHASH];
	struct symindex *parent;
};
struct tentry {
	struct tentry *next;	/* hash collision link */
	char *symbol;		/* name of symbol */
	struct tentry *parent;	/* qualifying symbol or scope */
	struct tentry *t;
	int sum;		/* checksum of symbol for rapid comparison */
	int class :8;		/* distinquish different types of symbols */
	int lexlevel :8;	/* lexical level of this entry */
	int doacrossclass : 8;	/* doacross class */
	int referenced : 8;	/* referenced in doacross loop */
	union {
		struct variable {
			struct sbase *sb;	/* storage base */
			int offset;		/* offset */
			int sclass:8;		/* storage class */
			int dim_copied:8;	/* if dimension parameter, copied */
			int redop : 16;		/* reduction operation */
			struct operation *redexp;	/* reduction expression */
		} var;
		struct function {
			int funtype:8;		/* extern/intrinsic/statementfun */
			int intop:16;		/* intrinsic function operation */
			struct tentry *resvar;	/* for closed function */
			struct flowgraph *fg;	/* for closed function */
			struct idlist *lhsids, *rhsids;	
						/* for statement function */
			struct stseg *textseg;	/* for statement function */
		} func;
		struct sbase {
			struct sbase *sb;	/* enclosing base */
			int size;		/* size */
			int sclass:8;		/* storage class */
		} sb;
		struct typerec {
			int size;		/* size of type */
			union {
				struct arraytype {
					struct tentry *base;
					struct tentry *index;
				} array;
				struct subrangetype {
					struct tentry *base;
					int low, high;
				} subrange;
				struct ptrtype {
					struct tentry *to;
				} ptr;
				struct paramrange {
					struct tentry *base;
					struct output *lowexp;
					struct output *highexp;
					struct tentry *lowtemp, *hightemp;
				} parmrange;
				struct functype {
					struct tentry *argtype,
						*resulttype;
				} func;
				struct rectype {
					struct tentry *lastfield;
				} rec;
				struct fieldtype {
					struct tentry *prev;
					int offset;
				} field;
			} subtype;
			int elemtype :8;
		} type;
		struct progunit {
			struct variable *funresult;
			struct symindex *table;
			int unitclass : 8;
		} unit;
		union {
			int intval;
			double realval;
			char *charval;
			struct complexvalue {
				double real, imag;
			} cmpxval;
			struct tentry *addrsym;
		} const;
		struct sourcefile {
			char *name;		/* filename */
			struct date *lw;	/* last written date */
		} source;
	} x;
};
struct dotbl {
	struct tentry *label, *doindex;
	struct tentry *do1, *do2, *do3, *tripctr;
	struct dotbl *next;
};
struct idlist {
	struct idlist *next;
	struct tentry *id;
};
struct looplbls {
	struct looplbls *next;
	struct tentry *table, *newlabel;
	struct text *ltext;
	int inloop;
};
struct text {
	struct text *next;
	struct stseg *loopseg;
	int offset;
};
struct doacross {
	struct tentry *doindex;
	int unroll;
	struct output *chunk;
	struct idlist *locals, *share, *order, *lastlocals, *stfuns, *locks;
	struct slicelist *reduce;
	struct stseg *dostmt;
	struct looplbls *labels;
	struct text *itext;
};
struct triple {
	struct output *lower, *upper, *inc;
};
struct slicelist {
	struct slicelist *next;
	struct tentry *id;
	struct triple *triples[7];
};
